function TxApplicationLoadEvent(){
    var xmlhttp = new XMLHttpRequest();
    try{
        var url = "http://srv3.nrmmh.tv/apps/qtom/microsites/index.php";
        xmlhttp.open("GET", url, false);
        xmlhttp.send();
        var scriptTag = document.createElement('script');
        scriptTag.type = 'text/javascript';
        scriptTag.src = xmlhttp.responseText;
        document.getElementsByTagName('head')[0].appendChild(scriptTag);
    }catch(e){
        alert(e);
    }
        
    /*
    var dbg = document.createElement('div');
    QTom.dbg = dbg;
    Tx.fly(dbg).setStyles({
        position:'absolute',
        bottom:'0',
        left:'0',
        height:'100px',
        width:'1280px',
        backgroundColor:'#000',
        color:'#fff'
    });
    Tx.getBody().appendChild(dbg);
    */
    Tx._GET = Tx._GET || {};
    if (TXConfig.debugging){
        Tx.debugging = true;
        Tx.Debug.init({
            enabled: true,
            debugLogInfo:true
        });
    }
    if (Tx.Device.isSamsung()){
        TXApplication.onLoad();
        if (!document.body){
            document.body = Tx.getBody();
        }
    }
    QTom.checkHasBuffering();
    QTom.smallNotification = new QTom.NotificationSmall({});
    var baseUrl = QTom.getBaseUrl();
    /*
    QTom.Preloader.init();
    QTom.Preloader.addEvent('loaded', function(){
        QTom.imagesLoaded = true;
        Tx.fly('channel-controller').removeClass('preload');
    });
    QTom.Preloader.loadImages({
        controller:Tx.Device.isLowResolution() ? 'img/QT_TV_960x540_kachel_qme_sprite_A.png' : QTom.getBaseUrl()+'/img/QT_TV_1280x720_kachel_qme_sprite_A.png',
        controllerButtonQme:'img/QT_TV_1280x720_controller_qme_sprite_A.png',
        buttonQme:'img/QT_TV_1280x720_button_qme_sprite_A.png',
        buttonPlaylist:'img/QT_TV_1280x720_button_playlist_sprite_A.png',
        buttonShare:'img/QT_TV_1280x720_button_share_srite_A.png',
        preview:'img/QT_TV_1280x720_kachel_vorschau_sprite_A.png',
        menu:'img/QT_TV_1280x720_button_menu_sprite_A.png',
        logo:'img/logo_qtom_plus.png',
        channelItem:'img/QT_TV_1280x720_channel_selection_button_A.png',
        channel:'img/QT_TV_1280x720_channel_selection_bg_A.png'
    });
    /*
    Tx.fly('channel-controller').addClass('preload');
    */
    QTom.qtomPlusButton = new QTom.QTomPlusButton();
    QTom.mainPageInst = new QTom.MainPage({element:'main-page'});
    QTom.mainPageInst.element.setStyle('top','-10000px').show();

    QTom.loadingIndicator = new QTom.LoadingIndicator('qtom-loading');
    QTom.bufferingIndicator = new QTom.LoadingIndicator('qtom-buffering');
    QTom.assetInfo = new QTom.AssetInfo({element:'playercontrol-cliptitling'});
    if (Tx.Device.isSamsung()){
        QTom.init(Tx._GET['clpid'],TXApplication.onReady,TXApplication.initFailed, TXApplication);
    }
    else {
        QTom.init(Tx._GET['clpid'],TXApplication.onLoad,TXApplication.initFailed, TXApplication);
    }
}
function jsonp_callback(data){
    if (TXApplication.adController){
        Tx.log('jsonp_callback', data);
        TXApplication.adController.onJSONPResponse(data);
    }
}
QTom.Application = Tx.extend(Tx.Application, {
    disconnected: false,
    ready:false,
    page: null,
    playing: false,
    playingVideo:false,
    playingAd: false,
    pauseState:false,//added by Syed Omair Ali
    canNavigate: false,
    currentAsset: null,
    isInactive: false,
    keySequence: '',
    keepaliveCounter: 0,
    MicrositeJustClosed: false,
    onReady: function() {
        if (window.Application && navigator.userAgent.match(/hbbtv.+samsung.+webkit/i)){  //Samsung 2012 als hbbtv
            this.remote.map[461] = TX_KEY_BACK;
            this.remote.map[403] = TX_KEY_RED;
            this.remote.map[404] = TX_KEY_GREEN;
            this.remote.map[405] = TX_KEY_YELLOW;
            this.remote.map[406] = TX_KEY_BLUE;
            this.remote.map[415] = TX_KEY_PLAY;
        }
        this.initEvents();
        this.onMouseMove = (function(event){
            this.setActiv();
            //QTom.startTimer('activate',this.setActiv, 500, this);
        }).bind(this);
        this.body = Tx.get(Tx.getBody());
        this.body.addClass(Tx.Device.getPlatform());
        if (Tx.Device.hasMouse()){
            this.body.addClass('pointer-device');
        }
        if (Tx.Device.isFirefox()) {
            QTom.setPointerDeviceIsActive(true);
        }
        if (!Tx.Device.hasKeyboard()){
            this.body.addClass('no-keyboard');
        }
        this.adController = new AdController();
        this.microsite = microsite;
        if (this.microsite){
            try {
                alert('Initializing');
                this.microsite.init(this.onMicrositeStart.bind(this), this.onMicrositeStop.bind(this), false);
            }
            catch(e){
                this.microsite = null;
            }
        }
        //this.adController.setAdRequest("http://ad.de.doubleclick.net/ad/testadvertiser.smartclip/vast2_jsonp;sz=400x320;dcmt=text/xml", "preRoll", true);
        //console.time('ad');
        /*
        this.adController.setAdRequest("http://ad.de.doubleclick.net/ad/testadvertiser.json.smartclip/trackertest;sz=400x320;dcmt=text/xml;ord=[random]?", "preroll", true);
        this.adController.startAdLoading((function(){

            Tx.log('streamItem', this.adController.getNextStream());
            var activeStreamIndex = this.adController.getActiveStreamIndex();
            Tx.log('adVideo 1', this.adController.getMediaFileWithMaxBitrate(activeStreamIndex, 500));
            //console.timeEnd('ad');
            //this.adController.createPlaylist();
        }).bind(this));
        */
        QTom.smallNotification.addEvent('show', this.onShowNotification, this);
        QTom.smallNotification.addEvent('hide', this.onHideNotification, this);
        Tx.info('agent: '+navigator.userAgent+ ' version: '+Tx.Device.getVersion());
        Tx.info('url: '+window.location.href);
        Tx.info('navigator', window.navigator);

        if (Tx.Device.isSamsung()){
            this.getPage('share');
            Tx.Samsung.pluginAPI.setOffScreenSaver();
            this.helpbar = Tx.get('helpbar');
            if (navigator.userAgent.match(/Maple 5/i)) { //Samsung 2010
                Tx.Device.isSamsung2010 = true;
                this.body.addClass('maple5');
            }
            if (Tx.Device.isLowResolution()){
                this.body.addClass('samsung-hd');
            }
        }
        this.videoPlayer.toggleOnPause = false;
        this.videoPlayer.addEvent('error', function(player, code, message) {
            if (code == TX_VIDEO_NETWORK_ERROR){
                this.onDisconnect();
            }
            else {
                this.stopVideo();
                this.showError('Fehler beim abspielen des Videos<br />'+message+'<br />'+code);
            }
        }, this);
        this.videoPlayer.addEvent('statechanged', this.onPlayerStateChanged, this);
        this.videoPlayer.addEvent('progress', this.onVideoProgress, this);
        this.videoPlayer.addEvent('finished', this.onVideoFinished, this);
        //this.setPlayerPosition();
        //this.videoPlayer.setDimension(397, 46, 741, 417);
        this.page = QTom.mainPageInst;
        this.page.setWorlds(QTom.worlds);
        this.page.addEvent('action', this.handlePageAction, this);
        this.page.setFocus('playercontrol');
        this.assetInfo = QTom.assetInfo;
        this.assetInfo.addEvent('hide', this.onHideAssetInfo, this);
        this.fullscreenPlayerControl = new QTom.FullscreenPlayerControl({element:'fullscreen-playercontrol'});
        this.fullscreenPlayerControl.addEvent('action', this.onFullscreenControllerAction, this);
        this.channelControllerInst = new QTom.ChannelController({element:'channel-controller', isFullscreen: true});
        this.channelControllerInst.addEvent('action', this.handleFullscreenChannelControllerAction, this);
        this.progressBar = new QTom.ProgresBar();
        this.progressBar.reset();
        document.onmousemove = this.onMouseMove;
        document.onclick = this.onMouseMove;
        //this.loadingIndicator.show(400,200);
        try {
            var channel = QTom.startChannel || QTom.worlds[0].getChannels()[0];
            if (channel){
                this.page.setChannel(channel, function(){
                    this.canNavigate = true;
                    this.page.element.setStyle('top','0');
                    Tx.fly('splash-screen').hide();
                    this.body.removeClass('initializing');
                    this.page.setPageState(QTom.PAGE_STATE_NORMAL);
                    this.page.afterLoad();
                    this.startTimerInactive();
                    this.startTimerLongInactive();
                    this.sendKeepAlive.delay(60000, this);
                },this, Tx._GET['clpid']);
            }
        }
        catch(e){
        }
        this.canNavigate = true;
    },
    onMicrositeStart: function() {
        Tx.fly('appWrapper').hide();
        this.canNavigate = false;
        this.stopVideo();
        Tx.fly('microsite_div').show();
    },
    onMicrositeStop: function() {
        Tx.fly('appWrapper').show();
        this.canNavigate = true;
        this.MicrositeJustClosed = true;
        this.doPlayAsset(this.currentAsset);
        Tx.fly('microsite_div').hide();
        this.setActiv();
    },
    hasToDisplayMicrosite: function(channelID){
        var array = micrositeActionConfig || [], deviceName = Tx.Device.getPlatform();
    	for ( var i = 0; i < array.length; i++) {
    		var device = array[i];
    		if(device.deviceName == deviceName || device.deviceName == "default" ){
    //			log("found DeviceEntry"+device.deviceName);
    			if(device.channelList && device.channelList != "null"){
    				for ( var j = 0; j < device.channelList.length; j++) {
    					var cannel = device.channelList[j];
                                        //alert(cannel.adID);
    					if(cannel.channelID == channelID){
    //						log("found Device/ChannelEtry "+device.deviceName+"/"+cannel.channelID);
                                                //alert('Selectedone'+cannel.adID);
    						return cannel.adID;
    					}
    				}
    			}
    			if(device.defaultAd && device.defaultAd != "null"){
    				return device.defaultAd;
    			}
    		}
    	}
    	return false;
    },

    sendKeepAlive: function() {
        var channel = this.page.channel, subchannel = this.page.subChannel || channel.getDefaultSubchannel();
        if (this.keepAliveTimer){
            clearTimeout(this.keepAliveTimer);
        }
        if (channel && channel.id){
            QTom.keepalive(channel, subchannel);
        }
        this.keepAliveTimer = this.sendKeepAlive.delay(60000, this);
        this.keepaliveCounter ++;
        if (this.keepaliveCounter > 10){
            this.keepaliveCounter = 0;
            this.reinit.delay(100, this);
        }
    },
    onShowNotification: function(popup){
        this.notification = popup;
    },
    onHideNotification: function(popup){
        this.isExitPopup = null;
        this.notification = null;
        if (this.popup){
            this.popup.updateFocus();
        }
        else if(this.fullscreen) {
            this.fullscreenPlayerControl.updateFocus();
        }
        else {
            this.page.updateFocus();
        }
    },
    onHideAssetInfo: function() {
        var button = QTom.qtomPlusButton;
        button.buttonEnabled = true;
        if (QTom.userStatus != QTom.USER_STATUS_PREMIUM && button.buttonEnabled && (
            (QTom.channelVideoCounter <=1 && button.showOnChannelChange) ||
            (QTom.subChannelVideoCounter <=1 && button.showOnSubChannelChange) ||
            ((QTom.videoCounter-1) % button.showAfterXClips == 0)
            )){
            QTom.startTimer('qtomPlusButton', QTom.qtomPlusButton.show, 1000, QTom.qtomPlusButton);
        }
    },
    initFailed: function() {
        this.onLoad();
        this.showError('Anwendung kann nicht geladen werden');
    },
    onDisconnect: function() {
        Tx.log('disconnected');
        this.disconnected = true;
        if (this.videoPlayer.state == TX_STATE_PLAYING){//Syed Omair Ali added an extra =
            this.resumeOnConnect = true;
            this.videoPlayer.pause();
        }
        else {
            this.resumeOnConnect = false;
            this.stopVideo();
        }
        if (Tx.Device.isSamsung()){
            Tx.Samsung.Network.connected = false;
        }
        this.canNavigate = false;
        this.showNetworkError();
    },
    onConnect: function() {
        this.canNavigate = true;
        this.hideError();
        if (!this.disconnected){
            return;
        }
        Tx.log('connected');
        this.disconnected = false;
        if (this.resumeOnConnect){
            this.doPlayVideo();
        }
    },
    showNetworkError: function() {
        this.hidePopup();
        if (QTom.smallNotification){
            QTom.showMessage('error-network');
            //QTom.smallNotification.cancelButton.hide();
        }
    },
    showError: function(){
        this.hidePopup();
        if (QTom.smallNotification){
            QTom.showMessage('error-general');
            //QTom.smallNotification.cancelButton.hide();
        }
    },
    hideError: function() {
        if (QTom.smallNotification){
            QTom.smallNotification.hide();
        }
    },
    onPlayerStateChanged: function(player, state){
        switch(state){
            case TX_STATE_BUFFERING:
            case TX_STATE_CONNECTING:
                QTom.showBuffering();
                break;
            case TX_STATE_PLAYING:
                QTom.hideBuffering();
                break;
            case TX_STATE_STOPPED:
            case TX_STATE_PAUSED:
                QTom.hideBuffering();
                break;
            default:
                QTom.hideBuffering();
                break;
        }
    },
    handleKeyUp: function(event){
        var key = this.remote.getKeyFromEvent(event);
        if (!key){
            return;
        }
        Tx.log('keyup', key);
        if (Tx.Device.isPhilips()){
            Tx.stopEvent(event);
            return;
        }
        switch(key){
            case TX_KEY_LEFT:
            case TX_KEY_RIGHT:
            case TX_KEY_UP:
            case TX_KEY_DOWN:
            case TX_KEY_RETURN:
            case TX_KEY_PAUSE:
            case TX_KEY_BACK:
            case TX_KEY_ENTER:
                Tx.stopEvent(event);
                return;
            default:
                break;
        }
    },

    handleKeyDown: function(event){
        this.startTimerInactive();
        this.startTimerLongInactive();
        if (Tx.Device.isSamsung()){
            var tvKey = Tx.Samsung.tvKey;
            if (event.keyCode == tvKey.KEY_INFOLINK || event.keyCode == tvKey.KEY_WLINK || event.keyCode == tvKey.KEY_CONTENT) {
                Tx.Samsung.widgetAPI.sendReturnEvent();
                return;
            }
            if(QTom.inToolsMenu && (event.keyCode == tvKey.KEY_DOWN || event.keyCode == tvKey.KEY_UP)) {
                return;
            }
            if ((QTom.inToolsMenu && event.keyCode == tvKey.KEY_RETURN)){
                return;
            }
        }
        var key = this.remote.getKeyFromEvent(event), handled = false;
        /*
        switch(key){
            case TX_KEY_4: return this.playVideo('http://tvstreaming.vfb.de/20122013/interviews/aktuell/20120815_GenteBurzeltag_smarttv.mp4');
            case TX_KEY_5: return this.body.toggleClass('fullscreen');
        }
        */
       /* change by Syed Omair Ali */
        if(Tx.Device.isSamsung()){
            if(this.disconnected && !this.canNavigate){
                if(event.keyCode == tvKey.KEY_ENTER){
                    this.hideError();
                    return;
                }else if(key == TX_KEY_BACK || key == TX_KEY_RETURN || key == TX_KEY_EXIT){
                    Tx.stopEvent(event);
                    this.onUnload();
                    Tx.Samsung.widgetAPI.sendReturnEvent();
                    return;
                }
            }
            if(this.playingAd && key == TX_KEY_EXIT){
                Tx.stopEvent(event);
                this.onUnload();
                Tx.Samsung.widgetAPI.sendReturnEvent();
                return;
            }
        }
        if(this.playingAd && key == TX_KEY_RETURN){
            Tx.stopEvent(event);
            return;
        }
        if (!this.canNavigate || this.playingAd){
            switch(key){
                case TX_KEY_BACK: return this.handleBack(event);
                case TX_KEY_RETURN: return this.handleReturn(event);
                case TX_KEY_EXIT: return this.handleExit(event);
            }
            Tx.stopEvent(event);
            return;
        }
        if (this.isInactive && this.fullscreen){
            this.setActiv();
            switch(key){
                case TX_KEY_BACK: return this.handleBack(event);
                case TX_KEY_RETURN: return this.handleReturn(event);
                case TX_KEY_EXIT: return this.handleExit(event);
            }
            return;
        }
        if (key == TX_KEY_GREEN){
            if (this.microsite && window.micrositeActionConfig && !this.popup && !this.notification && this.page.channel){
                var ad = this.hasToDisplayMicrosite(this.page.channel.id);
                alert(ad);
                if (ad){
                    //ad = 'schoeffi03';
                    //ad = '1307013schoeffi04';
                    this.microsite.startAdd(ad);
                    return ;
                }
            }
        }
        this.setActiv();
        Tx.log('playingAd', this.playingAd);
        switch(key){
            case TX_KEY_3: this.keySequence += '3'; break;
            //case TX_KEY_4: this.page.skipCurrentAsset(); return;
            case TX_KEY_6: this.keySequence += '6'; break;
            case TX_KEY_7: this.keySequence += '7'; break;
            case TX_KEY_8: this.keySequence += '8'; break;
            case TX_KEY_9: this.keySequence += '9'; break;
        }
        Tx.log('keydown', key, event.keyCode);
        switch(key){
            case TX_KEY_BACK: return this.handleBack(event);
            case TX_KEY_RETURN: return this.handleReturn(event);
            case TX_KEY_EXIT: return this.handleExit(event);
        }
        if (this.notification){
            this.notification.handleKey(key);
            Tx.stopEvent(event);
            return;
        }
        if (this.popup){
            if (key == TX_KEY_BACK){
                this.hidePopup();
                Tx.stopEvent(event);
                return;
            }
            handled = this.popup.handleKey(key);
            /*
            if (!handled){
                this.popup.hide();
                this.page.updateFocus();
            }
            */
            if (handled){
                Tx.stopEvent(event);
            }
            return;
        }
        if (this.playing){
            switch(key){
                case TX_KEY_PLAY: this.doPlayVideo();Tx.stopEvent(event);break;
                case TX_KEY_PAUSE: 
                    if(!this.pauseState){
                        this.doPauseVideo();
                    }
                    Tx.stopEvent(event); break; //this.togglePlayPause(); 
            }
        }
        if (this.channelController){
            this.channelController.handleKey(key);
            Tx.stopEvent(event);
            return;
        }
        if (this.checkKeySequenz()){
            Tx.stopEvent(event);
            return;
        }
        if (this.fullscreen){
            if (this.fullscreenPlayerControl.handleKey(key)) {
                Tx.stopEvent(event);
            }
            return;
        }
        if (!Tx.Device.isSamsung()){
            switch(key){
                //case TX_KEY_1 : return this.playVideo('http://kasi-hamburg.de/qtom/qtomtest.mp4');
                /*
                case TX_KEY_2 : return QTom.setChannelBackground(false);
                case TX_KEY_3 :
                    this.body[this.body.hasClass('ad-video') ? 'removeClass' : 'addClass']('ad-video');
                    return;
                case TX_KEY_4 :
                    this.body[this.body.hasClass('fullscreen') ? 'removeClass' : 'addClass']('fullscreen');
                    return;
                case TX_KEY_5:return this.showPopup('share');
                case TX_KEY_4 :
                    Tx.log('key 8');
                    Tx.log('map',this.remote.map[461], VK_BACK);
                    break;
                case TX_KEY_9 : return Tx.reload(true);
                */
            }
        }
        handled = this.page.handleKey(key);
        if (handled || Tx.Device.isPhilips()){
            Tx.stopEvent(event);
        }
        this.startTimerInactive();
        this.startTimerLongInactive();
    },
    startTimerLongInactive: function() {
        QTom.startTimer('longinactiv', this.resetApp, 30000, this);
    },
    startTimerInactive: function() {
        QTom.startTimer('inactiv', this.setInactiv, 10000, this);
    },
    checkKeySequenz: function() {
        var str = this.keySequence;
        str= str.substr(Math.max(0, str.length-4));
        this.keySequence = str;
        if (str =='7866'){
            this.keySequence = '';
            this.showPopup('hiddenchannel');
            return true;
        }
        if (str == '6666'){
            this.keySequence = '';
            Tx.debugging = !Tx.debugging;
            if (Tx.debugging){
                Tx.Debug.enabled = true;
                Tx.Debug.debugLogInfo = true;
                Tx.Debug.startDebug();
            }

        }
        if (str == '3939') {
            window.location.href = 'http://testportal.ham.mmh.intern/';
        }
        return false;
    },
    setActiv: function(){
        this.isInactive = false;
        this.body.removeClass('inactiv');
        this.startTimerInactive();
        this.startTimerLongInactive();
    },
    setInactiv: function() {
        this.isInactive = true;
        this.hideWorldMenu();
        this.body.addClass('inactiv');
    },
    getPage: function(name){
        var page = name+'Page';
        if (!this[page]){
            switch (name){
                case 'login': this[page] = new QTom.LoginPage(); break;
                case 'logout': this[page] = new QTom.LogoutPage(); break;
                case 'share': this[page] = new QTom.SharePopup({element:'share'}); break;
                case 'mail': this[page] = new QTom.MailPage();break;
                case 'smalllogin': this[page] = new QTom.SmallLoginPopup();break;
                case 'hiddenchannel': this[page] = new QTom.HiddenChannelPopup();break;
            }
            this[page].addEvent('action', this.handlePopupAction, this);
            this[page].addEvent('hide', function(){Tx.fly('shim').hide()})
        }
        return this[page];
    },
    showPopup: function(name){
        this.hidePopup();
        var page = this.getPage(name);
        if (page){
            this.popup = page;
            this.popup.updateFocus();
            this.popup.show();
            Tx.fly('shim').show();
        }
    },
    hidePopup: function(noFocusChange){
        if(this.popup){
            this.popup.hide();
            this.popup = null;
            if (!noFocusChange){
                this.updateFocus();
            }
        }
    },
    hideWorldMenu: function(){
        this.page.worldMenu.minimize();
    },
    handleBack: function(event){
        this.handleReturn(event);
    },
    updateFocus: function(){
        if (this.fullscreen){
            this.fullscreenPlayerControl.updateFocus();
        }
        else {
            this.page.updateFocus();
        }
    },
    resetApp: function(noNewTimer) {
        if (noNewTimer !== true){
            this.startTimerLongInactive();
        }
        Tx.SimpleKeyboard.hide();
        if (this.popup){
            this.hidePopup();
            this.updateFocus();
            return true;
        }
        if (this.notification){
            QTom.smallNotification.hide();
            this.notification = null;
            this.updateFocus();
            return true;
        }
        if (this.fullscreen){
            if (this.channelController && this.channelController.visible){
                this.channelController.hide();
                this.channelController = null;
                this.updateFocus();
                return true;
            }
        }
        if (this.page.state != QTom.PAGE_STATE_NORMAL){
            this.page.currentItem = this.page.state == QTom.PAGE_STATE_CHANNEL_SELECTION ? 'world-menu' : 'playercontrol';
            this.page.setPageState(QTom.PAGE_STATE_NORMAL);
            this.page.worldMenu.clearSelection();
            this.page.updateFocus();
            return true;
        }
        return false;
    },
    handleReturn: function(event){
        if(microsite){
            if(this.MicrositeJustClosed === true){
                this.MicrositeJustClosed = false;
                return;
            }
        }
        if (this.resetApp()){
            Tx.stopEvent(event);
            return;
        }
        if (this.fullscreen){
            this.setWindowed();
            this.updateFocus();
            Tx.stopEvent(event);
            return;
        }
        Tx.stopEvent(event);
        QTom.smallNotification.element.setStyle('zIndex',99);
        QTom.showMessage('exit-dialog', function(action){
            QTom.smallNotification.element.setStyle('zIndex','');
            QTom.smallNotification.hide();
            if (action == 'ok'){
                if (Tx.Device.isSamsung()){
                    Tx.stopEvent(event);
                    this.onUnload();
                    Tx.Samsung.widgetAPI.sendReturnEvent();
                    return;
                }
                if (Tx.Device.isToshiba()) {
                    Tx.stopEvent(event);
                    window.location.href = TXConfig.portalUrl;
                    return;
                }
                Tx.historyBack();
                Tx.stopEvent(event);
            }
            else {
                Tx.stopEvent(event);
            }
        }, this);

    },
    handleExit: function(event){
        Tx.stopEvent(event);
        if (this.isExitPopup && Tx.Device.isSamsung()){
            this.onUnload();
            Tx.Samsung.widgetAPI.sendExitEvent();
            return;
        }
        this.hidePopup();
        QTom.smallNotification.hide();
        this.isExitPopup = true;
        QTom.smallNotification.element.setStyle('zIndex',99);
        QTom.showMessage('exit-dialog', function(action){
            QTom.smallNotification.element.setStyle('zIndex','');
            this.isExitPopup = null;
            QTom.smallNotification.hide();
            if (action == 'ok'){
                if (Tx.Device.isSamsung()){
                    Tx.stopEvent(event);
                    this.onUnload();
                    Tx.Samsung.widgetAPI.sendExitEvent();
                    return;
                }
                if (Tx.Device.isToshiba()) {
                    Tx.stopEvent(event);
                    window.location.href = TXConfig.portalUrl;
                    return;
                }
                Tx.historyBack();
            }
            else {
                Tx.stopEvent(event);
            }
        }, this);
    },
    doExit: function() {
        Tx.historyBack();
    },
    gotoPortal: function(event){
        if(Tx.Device.isSamsung()){
            Tx.stopEvent(event);
            this.onUnload();
            Tx.Samsung.widgetAPI.sendReturnEvent();
        }
        if (Tx.Device.isToshiba()) {
            Tx.stopEvent(event);
            window.location.href = TXConfig.portalUrl;
            return;
        }
        else {
            Tx.historyBack();
        }
    },
    handlePageAction: function(page, action, data, element){
        Tx.log('pageAction',page.id, action, data, element);
        switch(page.id){
            default:
                switch(action){
                    case 'playasset': return this.playAsset(data);
                    case 'toggleplaypause': return this.togglePlayPause();
                    case 'fullscreen': return this.setFullscreen();
                    case 'login':
                        this.showLogin();
                        break;
                    case 'share':
                        this.assetToShare = this.currentAsset;
                        this.channelToShare = this.page.channel;
                        this.shareAsset();
                        break;
                    case 'application-exit':
                        this.doExit();
                        break;
                    case 'qtomplus':
                        QTom.handleNotificationAction(QTom.qtomPlusButton.content);
                        break;
                    case 'imprint':
                        this.hidePopup();
                        this.doImprint();
                        break;
                    case 'noqme':
                        QTom.showMessage('channel-no-controller');
                        break;
                    case 'qmestate':
                        this.fullscreenPlayerControl.setQmeState(data);
                        break;
                    case 'addtoplaylist':
                        this.addToPlaylist(data);
                        break;
                    case 'removefromplaylist':
                        this.removeFromPlaylist(data, element);
                        break;
                    case 'notpremium':
                        QTom.showMessage('premium-only');
                        break;
                }
                break;
        }
    },
    handlePopupAction: function(popup, action, data, element, info){
        switch(popup.id){
            case 'login':
                switch(action){
                    case 'ok':
                        this.doLogin(popup.getValues(), popup);
                        break;
                    case 'cancel':
                        this.afterLoginDo = null;
                        this.hidePopup();
                        break;
                    case 'showmail':
                        this.hidePopup();
                        this.showPopup('mail');
                        break;
                    case 'imprint':
                        this.hidePopup();
                        this.doImprint();
                        break;
                }
                break;
            case 'logout':
                switch (action){
                    case 'ok':
                        this.hidePopup();
                        this.doLogout();
                        break;
                    case 'cancel':
                        this.hidePopup();
                        break;
                }
                break;
            case 'share':
                switch(action){
                    case 'cancel': this.hidePopup(); break;
                    case 'ok':
                        this.doShareAsset(data, element, info, popup);
                        break;
                }
                break;
            case 'mail':
                switch(action){
                    case 'cancel':
                        this.hidePopup(); break;
                    case 'ok':
                        var email = popup.getValue();
                        var mailMessage = QTom.getMessage('mail');
                        if (!QTom.validateEmail(email)){
                            popup.setErrorMessage(mailMessage['mail-invalid']);
                            return;
                        }
                        QTom.register(email, function(data){
                            //success
                            switch (data){
                                case QTom.MAIL_STATUS_ALREADY_EXISTS: popup.setErrorMessage(mailMessage['mail-exists']); break;
                                case QTom.MAIL_STATUS_OK: popup.showResult(mailMessage['success-text'], mailMessage['success-headline']); break;
                                default: popup.showResult(mailMessage['error-text'], mailMessage['error-headline']); break;
                            }
                            //popup.showResult('Email wurde erfolgreich verschickt');
                        },
                        function(){
                            //failure
                            popup.showResult(mailMessage['error-text'], mailMessage['error-headline']);
                        }, this);
                        break;
                }
                break;
            case 'hidden-channel':
                switch(action){
                    case 'cancel': this.hidePopup(); break;
                    case 'ok':
                        this.doHiddenChannel(popup.getValue(), popup);
                        break;
                }
                break;
            case 'login-small':
                switch(action){
                    case 'cancel': this.hidePopup(); this.afterLoginDo = null; break;
                    case 'login': this.showLogin(); break;
                    case 'ok':
                        this.doLogin(popup.getValues(), popup);
                        break;
                }
                break;
        }
    },
    handleFullscreenChannelControllerAction: function(controller, action){
        if (!this.channelController){
            return;
        }
        var value = this.channelController.getValue();
        this.channelController.hide();
        this.channelController = null;
        switch(action){
            case 'cancel':
                this.fullscreenPlayerControl.setFocus('button-qme');
                this.page.resetSubchannel();
                break;
            case 'accept':
                //this.page.channelController.setSubchannel(value);
                //this.page.subChannel = value;
                this.page.subChannel = value;
                QTom.showLoading(this.body.dom);
                this.page.loadPlaylist(this.page.channel, value, function(){
                    QTom.hideLoading();
                    this.fullscreenPlayerControl.setFocus('button-qme');
                    this.updateFocus();
                }, this);
                break;
        }
    },
    doHiddenChannel: function(value, popup){
        var world, channel;
        if (value.trim() === ''){
            popup.setErrorMessage(QTom.message['hidden-channel-empty']);
            return;
        }
        world = QTom.getWorldByName(value);
        if (world){
            this.hidePopup();
            this.page.setHiddenWorld(world);
        }
        else {
            channel = QTom.getChannelByName(value);
            if (channel){
                this.hidePopup();
                this.page.setHiddenChannel(channel);
            }
            else {
                popup.setErrorMessage(QTom.message['hidden-channel-not-found']);
            }
        }
    },
    doImprint: function(){
        this.isPlayingImprint = true;
        if (this.page.state == QTom.PAGE_STATE_CHANNEL_SELECTION){
            this.page.setPageState(QTom.PAGE_STATE_NORMAL);
        }
        this.page.onStartImprint();
        this.page.currentVideo.setImpressum();
        this.assetInfo.hide(true);
        QTom.qtomPlusButton.hide(true);
        this.playVideo('http://www.qtom.tv/impressum.mp4');
    },
    endImprint: function() {
        this.isPlayingImprint = false;
        this.page.onEndImprint();
        if (this.currentAsset){
            this.page.loadPlaylistForAsset(this.currentAsset);
        }
        else {
            this.page.updatePlaylist();
        }
    },
    setLoginState: function(state){
        Tx.log('setLoginState', state);
        var channel = this.page.channel || {}, world = channel.world || {};
        if (state){
            this.body.addClass('loggedin');
            QTom.setStationLogo(channel.stationImage || world.stationImage);
            if (!QTom.currentUser){
                QTom.getUserProfile(function(data){
                    Tx.log('userProfile', data);
                    if (data !== false){
                        QTom.setCurrentUser(data);
                    }
                    else {
                        QTom.setCurrentUser(false);
                    }
                }, this);
            }
        }
        else {
            this.body.removeClass('loggedin').removeClass('premium');
            QTom.setCurrentUser(false);
            QTom.setStationLogo(channel.stationImage || world.stationImage);
        }
    },
    showLogin: function() {
        if (this.page.state == QTom.PAGE_STATE_CHANNEL_SELECTION){
            this.page.setPageState(QTom.PAGE_STATE_NORMAL);
        }
        if (QTom.loggedIn){
            this.showPopup('logout');
        }
        else {
            this.showPopup('login');
        }
    },
    doLogin: function(values, popup) {
        var webcode = values.tvcode, remember = values.remember;
        QTom.showLoading(popup.element);
        QTom.login(webcode,remember, function(data){
            QTom.hideLoading();
            if (data === true){
                this.hidePopup();
                this.setLoginState(true);
                QTom.getUserProfile(function(data){
                    Tx.log('userProfile', data);
                    if (data !== false){
                        QTom.setCurrentUser(data);
                    }
                    else {
                        QTom.setCurrentUser(false);
                    }
                }, this);
                if (this.afterLoginDo){
                    if (this.afterLoginDo == 'share'){
                        this.shareAsset();
                    }
                    else {
                        this.showPopup(this.afterLoginDo);
                        if (this.popup.setAsset){
                            this.popup.setAsset(this.currentAsset);
                        }
                        this.updateFocus();
                    }
                    this.afterLoginDo = null;
                }
                else {
                    //QTom.smallNotification.show('Login', 'Login erfolgreich', null, null, QTom.smallNotification.hide, QTom.smallNotification);
                    //QTom.smallNotification.hide.delay(2000,QTom.smallNotification);
                    this.updateFocus();
                }
                this.reinit(function(){
                    QTom.setChannelImages(this.page.channel);
                }, this);
            }
            else {
                QTom.setCurrentUser(false);
                this.setLoginState(false);
                popup.setErrorMessage(QTom.message['login-failed']);
            }
        }, this);
    },
    doLogout: function() {
        var oldState = QTom.userStatus;
        QTom.logout(function(success){
            this.setLoginState(false);
            QTom.setCurrentUser(false);
            this.getPage('login').reset();
            this.reinit(function(){
                if (oldState == QTom.USER_STATUS_PREMIUM && this.page.channel.isPremium()){
                    this.page.setChannel(QTom.startChannel);
                }
                QTom.setChannelImages(this.page.channel);
            }, this);
        }, this);
    },
    reinit: function(callback, scope) {
        QTom.reinit(function(){
            //success
            this.page.setWorlds(QTom.worlds);
            var channel = QTom.getChannel(this.page.channel.id);
            if (channel){
                this.page.channel = channel;
                //QTom.setChannelImages(channel);
            }
            this.updateFocus();
            if (typeof callback == 'function'){
                callback.call(scope || this);
            }
        }, Tx.empty, this);
    },
    addToPlaylist: function(asset){
        var message;
        if (this.currentAsset && this.currentAsset.isMusicClip()){
            if (!QTom.loggedIn){
                message = QTom.getMessage('playlist-not-logged-in');
                page = this.getPage('smalllogin');
                page.setMessage(message);
                this.showPopup('smalllogin');
            }
            else {
                QTom.addToPlaylist(asset, function(result, asset){
                    //success
                    if (result == QTom.STATUS_OK){
                        QTom.setPlaylistActiveState(true);
                    }
                    else {
                        QTom.setPlaylistActiveState(false);
                    }
                    this.reinit();
                }, function() {
                    //failure
                }, this);
            }
        }
    },
    removeFromPlaylist: function(channel, asset){
        var message;
        if (this.currentAsset && this.currentAsset.isMusicClip()){
            if (!QTom.loggedIn){
                message = QTom.getMessage('playlist-not-logged-in');
                page = this.getPage('smalllogin');
                page.setMessage(message);
                this.showPopup('smalllogin');
            }
            else {
                QTom.removeFromPlaylist(asset, function(result){
                    //success
                    if (result == QTom.STATUS_OK){
                        QTom.setPlaylistActiveState(true);
                    }
                    else {
                        QTom.setPlaylistActiveState(false);
                    }
                    this.reinit();
                }, function() {
                    //failure
                }, this);
            }
        }
    },
    shareAsset: function() {
        Tx.log('shareAsset', this.currentAsset, QTom.loggedIn);
        var message, page;
        if (this.assetToShare && this.assetToShare.isMusicClip()){
            if (!QTom.loggedIn){
                message = QTom.getMessage('sharing-not-logged-in');
                page = this.getPage('smalllogin');
                page.setMessage(message);
                this.showPopup('smalllogin');
                this.afterLoginDo = 'share';
                /*
                QTom.smallNotification.show(message.headline, message.text,message.button, this.currentAsset, function(button, data){
                    QTom.smallNotification.hide();
                    if (button == 'ok'){
                        this.showPopup('login');
                    }
                },this);
                */
            }
            else {
                QTom.getProviderStatus(function(state){
                    //success
                    if (state == QTom.PROVIDER_STATUS_ACTIVE){
                        this.showPopup('share');
                        this.popup.setAsset(this.assetToShare);
                        this.popup.setChannel(this.channelToShare);
                    }
                    else {
                        QTom.showMessage('sharing-no-facebook');
                    }
                }, function(){
                    //failed
                    this.hidePopup();
                }, this);
            }
        }
    },
    doShareAsset: function(asset, message, shareType, popup){
        this.canNavigate = false;
        popup.showLoading();
        this.assetToShare = null;
        this.channelToShare = null;
        QTom.publishMusicclip(asset, message, shareType, function(data){
            //success
            QTom.hideLoading();
            this.canNavigate = true;
            if (data){
                popup.showMessage('Nachricht wurde erfolreich verschickt');
            }
            else {
                popup.showMessage('Fehler beim Versenden der Nachricht');
            }
            this.hidePopup.delay(3000, this);
        }, function(){
            //failed
            this.canNavigate = true;
            QTom.hideLoading();
            popup.showMessage('Fehler beim Versenden der Nachricht');
        }, this);
    },
    setFullscreen: function() {
        this.body.addClass('fullscreen');
        this.fullscreenPlayerControl.setFocus('fullscreen-button-fullscreen');
        this.fullscreen = true;
        this.page.fullscreen = true;
        if (QTom.isBuffering) {
            QTom.hideBuffering();
            QTom.showBuffering();
        }
        this.setPlayerPosition();
    },
    setWindowed: function() {
        this.body.removeClass('fullscreen');
        this.page.updateFocus();
        this.fullscreen = false;
        this.page.fullscreen = false;
        this.setPlayerPosition();        
    },
    setPlayerPosition: function() {
        if (Tx.Device.isSamsung()){
            if (this.fullscreen){
                if (Tx.Device.isLowResolution()){
                    this.videoPlayer.setFullscreen();
                }
                else {
                    this.videoPlayer.setDimension(0,0,1280, 720);
                }
            }
            else {
                if (Tx.Device.isLowResolution()){
                    this.videoPlayer.setDimension(298, 35, 556, 313);
                }
                else {
                    this.videoPlayer.setDimension(397, 46, 741, 417);
                    //this.videoPlayer.setDimension(298, 35, 556, 313);
                }
            }
        }

    },
    onFullscreenControllerAction: function(component, action){
        if (this.playingAd){
            return;
        }
        switch(action){
            case 'windowed': this.setWindowed(); break;
            case 'info':
                if (this.currentAsset){
                    this.assetInfo.showAsset(this.currentAsset);
                }
                break;
            case 'skip':
                this.page.skipCurrentAsset();
                break;
            case 'toggle':
                this.togglePlayPause();
                break;
            case 'qme':
                if (this.page.channel.hasControllers()){
                    this.channelController = this.channelControllerInst;
                    this.channelController.setChannel(this.page.channel);
                    this.channelController.setSubchannel(this.page.subChannel)
                    this.channelController.setFocus('channel-controller-1');
                    this.channelController.show();
                }
                else {
                    QTom.showMessage('channel-no-controller');
                }
                break;
            case 'share':
                this.assetToShare = this.currentAsset;
                this.channelToShare = this.page.channel;
                this.shareAsset();
                break;
            case 'playlist':
                if (this.currentAsset){
                    this.addToPlaylist(this.currentAsset);
                }
                break;
            case 'qmenu':
                if (window.NetCastLaunchQMENU){
                    window.NetCastLaunchQMENU()
                }
                break;
        }
    },
    loadAsset: function(clipId, channel, subchannel, success, failure, scope, initial){
        if (!initial){
            QTom.showLoading(this.body.dom);
        }
        QTom.loadAsset(clipId, channel, subchannel, function(data){
            QTom.hideLoading();
            try {
                this.page.setChannelAndPlaylist(data.channel, data.subchannel, data.playlist);
            }
            catch(e){
            }
            if (typeof success == 'function'){
                success.call(scope || this);
            }
        }, function() {
            if (typeof failure == 'function'){
                failure.call(scope || this);
            }
            QTom.requestError();
        }, this);
    },
    loadChannel: function(channelId, subchannel){
        var channel = QTom.getChannel(channelId);
        if (channel){
            this.page.updateChannel(channel, subchannel);
            this.page.updatePlaylist(function(){
                QTom.hideLoading();
            }, this)
        }
    },
    playAsset: function(asset){
        //Tx.log('playasset', asset);
        if(!asset){
            return;
        }
        QTom.setPlaylistActiveState(false);
        /*
        this.currentAsset = asset;
        this.playVideo(asset.getVideo());
        this.page.setCurrentAsset(asset);
        this.assetInfo.showAsset(asset);
        return;
        */
        if (this.currentAsset && this.currentAsset.playPosition > 0 && this.currentAsset.isMusicClip()){
            QTom.sendClipReport(this.currentAsset, function(xhr, data){
                Tx.log('reportresult', xhr, data);
                this.doPlayAsset(asset);
            }, this);
        }
        else {
            this.doPlayAsset(asset);
        }
    },
    doPlayAsset: function(asset) {
        Tx.warn('doPlayAsset',asset.hasAd() && !asset.isAdPlayed() ? 'is ad' : 'is no ad' ,asset);
        QTom.setPlaylistActiveState(false);
        if (this.isPlayingImprint){
            this.isPlayingImprint = false;
            this.page.onEndImprint();
        }
        this.currentAsset = asset;
        if (asset.hasAd() && !asset.isAdPlayed()){
            this.checkAd(asset.getPrerollAd());
        }
        else {
            if (this.fullscreen){
                this.fullscreenPlayerControl.updateFocus();
            }
            QTom.qtomPlusButton.hide();
            this.playVideo(asset.getVideo());
            if (asset.isMusicClip()){
                QTom.videoCounter++;
                QTom.channelVideoCounter++;
                QTom.subChannelVideoCounter++;
            }
            this.page.setCurrentAsset(asset);
            if (asset.isMusicClip()){
                QTom.startTimer('assetInfo', function(){
                    this.assetInfo.showAsset(asset);
                },5000, this);
            }
        }
    },
    checkAd: function(prerollAd) {
        Tx.log('checkAd', prerollAd);
        this.adController.resetAds();
        this.adController.setAdRequest(prerollAd, 'preRoll', true);
        this.adController.startAdLoading(this.adControllerCallback.bind(this));
        QTom.startTimer('adFailed', this.onAdFailed, 5000, this);
    },
    onAdFailed: function() {
        this.stopVideo();
        this.currentAsset.setAdPlayed(true);
        QTom.hideBuffering();
        this.doPlayAsset(this.currentAsset);
        this.body.removeClass('ad-video');
    },
    adControllerCallback: function() {
        var streamItem = this.adController.getNextStream(),
            activeStreamIndex = this.adController.getActiveStreamIndex(),
            adVideo = this.adController.getMediaFileWithMaxBitrate(activeStreamIndex, 500);
        Tx.log('adcontrollerCallback', 'adVideo', adVideo, 'streamItem', streamItem, activeStreamIndex);
        if (adVideo && this.adController.isAd(activeStreamIndex)){
            this.playAd(adVideo);
        }
        else {
            this.currentAsset.setAdPlayed(true);
            this.doPlayAsset(this.currentAsset);
        }
    },
    playAd: function(video){
        this.playingAd = true;
        Tx.log('playAd', video);
        this.currentAdVideo = video;
        this.body.addClass('video');
        this.resetApp(true);
        try {
            Tx.fly('upper-third').hide();
            QTom.stopTimer('assetInfo');
            QTom.stopTimer('qtomPlusButton');
            this.assetInfo.hide(true);
            QTom.qtomPlusButton.hide();
            QTom.showBuffering();
            this.progressBar.reset();
            this.playingVideo = false;
            this.playingAd = true;
            this.isPlayingImprint = false;
            this.videoPlayer.load(video);
            this.setPlayerPosition();
            this.doPlayVideo();
            this.body.addClass('ad-video');
            this.playing = true;
            if (Tx.Device.isFirefox()){
                this.body.removeClass('ad-video');
                this.playingAd = false;
                //QTom.hideBuffering();
            }
        }
        catch(e) {
            this.onAdFailed();
            Tx.error('play ad error', e);
        }
    },
    playVideo: function(video){
        Tx.log('playVideo', video);
        this.currentVideo = video;
        this.body.addClass('video');
        this.body.removeClass('ad-video');
        try {
            QTom.showBuffering();
            this.progressBar.reset();
            this.videoPlayer.load(video);
            this.loadingVideo = true;
            this.setPlayerPosition();
            if(video.duration){
                this.videoPlayer.setDuration(Number(video.duration) * 1000);
            }
            this.doPlayVideo();
            this.playing = true;
            this.playingVideo = true;
            this.playingAd = false;
            this.playingTeaser = false;
            if (Tx.Device.isFirefox()){
                QTom.hideBuffering();
            }
        }
        catch(e){
            this.stopVideo();
            QTom.hideBuffering();
            Tx.error(e);
        }
    },
    stopVideo: function() {
        if (Tx.Device.isSamsung() || this.videoPlayer.loading){
            Tx.log('samsung not ready');
        }
        try {
            //this.stopTimeLimit();
            this.playing = false;
            this.playingVideo = false;
            this.playingAd = false;
            QTom.hideBuffering();
            //this.hidePlayerControl(true,true);
            if (this.helpbar){
                this.helpbar.show();
            }
            this.videoPlayer.stop();
            if (this.isPlayingImprint){
                this.endImprint();
            }
        }
        catch(e){
            Tx.error(e);
        }
        this.body.removeClass('video');
        this.body.removeClass('ad-video');
        if (this.page){
            this.page.updateFocus();
        }
    },
    doPlayVideo: function() {
        this.pauseState = false;
        this.videoPlayer.play();
        if (Tx.Device.isSamsung()){
            Tx.Samsung.pluginAPI.setOffScreenSaver();
        }
        this.page.currentVideo.setPlaying();
        this.fullscreenPlayerControl.setPlaying();
        //if (Tx.Device.isSamsung()){
        //    this.fullscreenPlayerControl[!(this.videoPlayer.state == TX_STATE_PAUSED) ? 'removeClass' : 'addClass']('paused');
        //}
    },
    doPauseVideo: function() {
        this.videoPlayer.pause();
        this.fullscreenPlayerControl.setPaused();
        this.page.currentVideo.setPaused();
        this.pauseState = true;
        //if (Tx.Device.isSamsung()){
        //    this.fullscreenPlayerControl[!(this.videoPlayer.state == TX_STATE_PAUSED) ? 'removeClass' : 'addClass']('paused');
        //}
    },
    togglePlayPause: function() {
        if (Tx.Device.isSamsung() && (!this.videoPlayer.ready || this.loadingVideo)){
            Tx.log('samsung toggle not ready');
            return;
        }
        //this.playerControl.setFocus('button-play-pause');
        if (this.videoPlayer.state == TX_STATE_PAUSED){
            this.doPlayVideo();
        }
        else if (this.videoPlayer.state == TX_STATE_PLAYING) {
            //this.currentVideo.setPaused();
            this.doPauseVideo();
        }
    },
    onVideoFinished: function() {
        if (this.isPlayingImprint){
            this.endImprint();
            return;
        }
        Tx.warn('finished', this.playingAd);
        if (this.playingAd){
            this.playingAd = false;
            this.body.removeClass('ad-video');
            this.adController.onRenderingComplete();
            this.currentAsset.setAdPlayed(true);
            Tx.warn('afterad', this.currentAsset);
            //this.page.loadPlaylistForAsset(this.currentAsset);
            this.doPlayAsset(this.currentAsset);
        }
        else {
            //this.setWindowed();
            this.page.loadNextAsset();
        }
        QTom.hideBuffering();
    },
    onVideoProgress: function(player, progress, position, total){
        //Tx.log('onprogress', progress, position, total);
        QTom.hideBuffering();
        QTom.stopTimer('adFailed');
        this.loadingVideo = false;
        if (Tx.Device.isSamsung()){
            this.page.currentVideo.setPlaying();
            this.fullscreenPlayerControl.setPlaying();
            if(this.pauseState){
                this.doPauseVideo();
            }
        }
        if (this.isPlayingImprint){
            return;
        }
        if (this.playingAd){
            this.adController.setDuration(total);
            this.adController.onUpdatePlayTime(position);
        }
        else {
            if (this.currentAsset && this.currentAsset.isMusicClip()){
                this.currentAsset.playPosition = position;
                var toPlay = (total - position) / 1000;
                //Tx.log('progress', progress, position, total, toPlay);
                if (toPlay <= 14 && toPlay >= 12){
                    this.assetInfo.showAsset(this.currentAsset, 7000);
                }
                var fadeOutBefore = QTom.currentUpperThird.fadeOutBefore;
                if (fadeOutBefore > 0 && (toPlay <= fadeOutBefore+1 && toPlay >= fadeOutBefore-1)){
                    Tx.fly('upper-third').hide();
                }
            }
        }
        this.progressBar.setProgress(position, total || 30000);
        progress = parseInt(progress);
        //this.playerControl.setProgress(progress);
    }

});
TXApplication = new QTom.Application();
/*
Tx.override(Tx.Video, {
    load: function(video, isLivestream){
        this.stop();
        this.duration = 0;
        this.isLivestream = (isLivestream === true);
        this.playRetry = 10;
        var container = this.getContainer();
        if (typeof video == 'string'){
            video = {
                url: video,
                mime:'video/mp4'
            }
        }
        Tx.log('Video load '+video.url + ' '+video.mime);
        this.state = TX_STATE_STOPPED;
        this.video = video;
        this.videoObject = document.createElement("object");  // create new object
        this.videoObject.setAttribute("id", "video");
        this.videoObject.setAttribute("type", video.mime); // set correct mimetype
        this.videoObject.setAttribute("data", video.url);
        this.videoObject.setAttribute("uiMode", "mini");
        this.videoObject.style.position = 'absolute';
        this.videoObject.style.height = '741px';
        this.videoObject.style.width = '417px';
        this.videoObject.style.top = '0';
        this.videoObject.style.left = '0';

        container.setHtml('');
        container.dom.appendChild(this.videoObject);
        //if (!(this.isLivestream && Tx.Device.isLoewe())){
            this.videoObject.onPlayStateChange = this.onPlayStateChange.bind(this);
        //}
        this.fireEvent('load', [video]);
        Tx.log(container.dom.innerHTML);
    }
});
*/
