
/* test 000000 */
Tx.apply(TXConfig, {
    serverUrl: 'server.php',
    //testDeviceId: '1234565432-001',
    ENVIRONMENT: 'production',
    dummyPreroll: 'http://ad.de.doubleclick.net/ad/testadvertiser.json.smartclip/trackertest;sz=400x320;dcmt=text/xml;ord=[random]?'
});
var QTom = {
    defaultStationLogo: 'img/logo_qtom.png',
    defaultPremiumStationLogo: 'img/logo_qtom_plus.png',
    message:{
        'login': {
            'header':'Login',
            'register-headline':'Warum registrieren',
            'register-text':'Registriere dich, um die Merkzettelfunktion zu nutzen oder Videos per Facebook zu sharen.',
            'mail-button':'Info per Mail',
            'advantage-headline':'Die Vorteile für Dich',
            'advantage-text':'Text',
            'tvcode-headline':'TV Code',
            'tvcode-text':'Den TV Code generierst du dir im Web',
            'tvcode-label': 'Tv-Code:',
            'button-ok':'Absenden',
            'checkbox-label':'Login merken',
            'marketing-headline':'QTom+',
            'marketing-text':'Als QTom+ Nutzer hast du die folgenden Vorteile:[br] - Programm unterbrechungswerbefrei ansehen[br] - Musikfernsehen für unterwegs[br] - unbegrenzt Playlisten erstellen[br] - Videos in besserer Qualität ansehen'
        },
        'logout': {
            'header' :'Logout',
            'headline' :'Du möchtest Dich ausloggen?',
            'text' :'Du bist dauerhaft eingeloggt, so lange Du Dich nicht ausloggst. Das hat den Vorteil, dass Du [br] sofort Videos in Premium-Qualität sehen, auf Deine persönlichen Playlistenzugreifen und [br] Musikvideos weiterleuiten kannst, sobald Du QTom startest. Wenn Du Dich trotzdem [br] ausloggen willst, drücke den Logout-Button.',
            'button-ok' :'Logout',
            'qtom-text' :'QTom Text'
        },
        'login-small': {
            'header' : 'Nur für eingeloggte Nutzer',
            'text' : 'Um Videos mit deinen Freunden zu teilen, musst du eingeloggt sein!',
            'label' : 'TV-Code:',
            'checkbox-label' : 'Login merken',
            'button-login' : 'Was ist TV-Code?',
            'button-ok' : 'Absenden'
        },
        'hidden-channel':{
            'header' : 'Passwort',
            'label' : 'Gib hier das Passwort ein:',
            'button-ok' : 'Jetzt aktivieren!'
        },
        'login-failed':'Ungültiger TV-Code',
        'hidden-channel-not-found':'Channel nicht gefunden',
        'hidden-channel-empty':'Bitte Wert eingeben',
        'mail': {
            'header' : 'Info per Mail',
            'text' : 'Damit Du alle QTom+ Features im vollem Umfang nutzen kannst, [br] musst Du Dich registrieren. Gehe hierzu ins Web unter [br] http://www.qtom.tv/+ oder gib hier Deine Email-Adresse ein [br] und wir senden Dir alle Infos zur Registrierung per Mail zu.',
            'label' : 'Deine Emailadresse:',
            'button-ok' : 'Infos anfordern!',
            'success-headline' : 'eInfos versandt',
            'success-text' : 'Wir haben dir alle Informationen an die von dir angegebene Emailadresse geschickt.',
            'mail-exists':'Die E-Mailadresse existiert bereits',
            'mail-invalid':'Emailadresse ungültig',
            'error-headline':'Fehler beim Mailversand',
            'error-text':'Mail konnte nicht verschickt werden. Versuche es später noch einmal'
        },
        'sharing-not-logged-in':{
            headline: 'Nur für eingeloggte Nutzer',
            text:'Um Videos mit deinen Freunden zu teilen, musst du eingeloggt sein!'
        },
        'playlist-not-logged-in':{
            headline:'Nur für eingeloggte Nutzer',
            text:'Um Musikvideos auf deinen Merkzettel zu legen, musst du eingelogt sein!'
        },
        'sharing-no-facebook':{
            headline: 'Facebook nicht aktiviert',
            text:'Du hast Facebook nicht in deinem Account freigegeben. Log dich über deinen PC ein und füge Facebook zu deinem Profil hinzu.'
        },
        'premium-only': {
            headline: 'Nur für QTom plus',
            text: 'Dieser Channel ist nur für QTom plus Kunden',
            button:{text:'Login', content:'login://'}
        },
        'channel-no-controller':{
            headline:'Kein Controller',
            text: 'Dieser Channel hat keine Controller'
        },
        'no-hidden-channel':{
            headline: 'Nicht gefunden',
            text: 'Eine Welt oder ein Channel mit diesem Namen existiert nicht'
        },
        'controller-text': {
            text:'Mit den Reglern kann du das Programm deinem persönlichen Geschmack anpassen.'
        },
        'exit-dialog':{
            headline:'QTom beenden',
            text:'Sicher beenden?',
            button:{text:'Beenden'}
        },
        'error-no-server': {
            headline:'Server nicht erreichbar',
            text:'Wow, unsere Server sind gerade überlastet. Bitte versuche es später noch einmal!'
        },
        'error-general':{
            headline:'Entschuldige bitte!',
            text:'Leider ist ein Fehler aufgetreten. Bitte versuche es erneut. Sollte der Fehler dauerhaft auftreten, informiere bitte unseren Support unter support@qtom.tv. [br]Vielen Dank! '
        },
        'error-network':{
            headline:'Zu geringe Bandbreite',
            text:'Leider hast du gerade eine zu langsame Internetverbindung. Bitte überprüfe deine Netzwerkanbindung, da es ansonsten zu Problemen beim Anschauen von QTom TV kommen kann. Bei Fragen wende dich an support@qtom.tv.'
        }
    }
};
if (Tx.Device.isSamsung()){
    Tx.apply(TXConfig, {
        //serverUrl:'http://samsung.qtom.tv/server.php',// 'http://samsung.app.qtom_v2.services.nrmmh.tv/server.php',//http://mmh.arielgrafik.de/qtom/server.php',//?environment=stagedev',
        //serverUrl:'http://samsung_test.qtom_v2.stage.services.nrmmh.tv/server.php',//http://mmh.arielgrafik.de/qtom/server.php',//?environment=stagedev',
        //serverUrl:'http://kasi-hamburg.de/qtom/server.php',//http://mmh.arielgrafik.de/qtom/server.php',//?environment=stagedev',
        //serverUrl:'http://mmh.arielgrafik.de/qtom/server.php',//todo ändern auf mmh ?environment=stagedev',
//        serverUrl:'http://samsung.qtom.mmh.arielgrafik.de/server.php',//this version didn't work premium channels available without login
        serverUrl:'http://samsung.qtom.tv/server.php',//todo ändern auf mmh ?environment=stagedev',
        debugging:false
    });
}
if (Tx.Device.isToshiba()) {
    Tx.apply(TXConfig, {
        portalUrl: 'https://dtvfront.toshibaplaces.com/tmsp-front-dtv/cindex.html'
    });
}

Tx.apply(Tx.Debug, {
    debugServer: (Tx.Device.isSamsung() ? 'http://mmh.arielgrafik.de' : '') + '/debugger/debugger_server.php?name=qtom'
});

/*
    192.168.17.41

    78.46.76.79
*/
