/**
 * Created with JetBrains PhpStorm.
 * User: kasi
 * Date: 15.05.12
 * Time: 12:56
 * To change this template use File | Settings | File Templates.
 */

/*
QTom.WorldMenu = Tx.extend(Tx.ScrollContainer, {
    vertical:true,
    minimized:false,
    canMinimize: true,
    selectable: true,
    multiselect:false,
    prevArrow: 'world-menu-arrow-up',
    nextArrow: 'world-menu-arrow-down',
    initComponent: function(){
        Tx.ScrollContainer.prototype.initComponent.apply(this, arguments);
        this.minimizedItem = new Tx.Component({element:'world-menu-minimized-text'});
        this.minimizedItem.addEvent('mouseover', function(){this.minimizedItem.setFocus(true)}, this);
        this.minimizedItem.addEvent('click', function(){this.maximize()}, this);
        this.element.query('.button-menu').each(function(el, index){
            this.add(new Tx.Component({element:el}));
        }, this);
        this.fx = new Tx.Animate();
        this.minHeight = Tx.Device.isLowResolution() ? 32 : 43;
        this.maxHeight = Tx.Device.isLowResolution() ? 160 : 215;
    },
    setFocus: function(state){
        //this.maximize();
        if (this.minimized && state === true){
            this.minimizedItem.setFocus(true);
            return;
        }
        else {
            this.minimizedItem.setFocus(false);
        }
        Tx.ScrollContainer.prototype.setFocus.apply(this, arguments);
    },
    focusNext: function(){
        if (this.focusIndex == 2 && this.canScrollNext()){
            this.scrollNext();
            return true;
        }
        return Tx.ScrollContainer.prototype.focusNext.apply(this, arguments);
    },
    focusPrev: function() {
        if (this.focusIndex == 2 && this.canScrollPrev()){
            this.scrollPrev();
            return true;
        }
        return Tx.ScrollContainer.prototype.focusPrev.apply(this, arguments);
    },
    scrollNext: function() {
        Tx.ScrollContainer.prototype.scrollNext.apply(this, arguments);
        if (this.selectedIndex !== null){
            this.selectedIndex++;
            this.updatedSelected();
        }
    },
    scrollPrev: function() {
        Tx.ScrollContainer.prototype.scrollPrev.apply(this, arguments);
        if (this.selectedIndex !== null){
            this.selectedIndex--;
            this.updatedSelected();
        }
    },
    updatedSelected: function() {
        if(this.selectedIndex !== null && this.selectedIndex >= 0 && this.selectedIndex < this.items.length) {
            this.selectItem(this.selectedIndex);
        }
    },
    handleKey: function(key){
        if (this.minimized){
            switch(key){
                case TX_KEY_ENTER:
                    this.maximize();
                    this.focusItem(this.focusIndex);
                    return;
                case TX_KEY_LEFT: return this.left;
                case TX_KEY_RIGHT: return this.right;
                case TX_KEY_UP:
                    return this.up;
                case TX_KEY_DOWN: return this.down;
            }
        }
        return Tx.ScrollContainer.prototype.handleKey.apply(this, arguments);
    },
    minimize: function() {
        if (this.canMinimize && !this.minimized){
            this.minimized = true;
            this.prevArrow.hide();
            this.nextArrow.hide();
            this.fx.animate(this.element.dom.style, 'height', 1000, this.maxHeight, this.minHeight, 'px', function(){
                this.element.addClass('minimized');
                Tx.fly('marketing-menu').show();
            }, this);
            if (this.hasFocus){
                this.minimizedItem.setFocus(true);
            }
        }
    },
    maximize: function() {
        Tx.fly('marketing-menu').hide();
        this.element.removeClass('minimized');
        this.fx.animate(this.element.dom.style, 'height', 1000, this.minHeight, this.maxHeight, 'px', function(){
            this.minimized = false;
            this.updateArrows();
        }, this);
        this.minimizedItem.setFocus(false);
    },
    canScrollPrev: function() {
        return !this.minimized && (this.dataOffset > 0);
    },
    canScrollNext: function() {
        return !this.minimized && (this.dataOffset + this.items.length < this.data.length);
    },
    toggle: function() {
        this[this.minimized ? 'maximize' : 'minimize']();
    },
    setData: function(data){
        Tx.ScrollContainer.prototype.setData.apply(this, arguments);
        this.element.removeClass('items-1').removeClass('items-2').removeClass('items-3').removeClass('items-4');
        if (data.length < 5){
            this.element.addClass('items-'+data.length);
        }
        this.scrollPrev();
    },
    focusLast: function() {
        if (!this.minimized){
            this.dataOffset = Math.max(0, this.data.length - 5);
            this.setItems();
            this.focusLastItem();
        }
    },
    focusLastItem: function() {
        //Tx.log('focusLast', Math.min(4, this.data.length-1));
        this.focusItem(Math.min(4, this.data.length-1));
    },
    setItem: function(item, data){

        if (data && data.name) {
            item.setHtml(data.name);
            item.world = data;
            item.setStyle('display','block');
        }
        else {
            item.setStyle('display', 'none');
        }
    },
    onAction: function() {
        var item = this.getFocusItem();
        if (item && item.world){
            this.fireEvent('action', [item, item.world]);
            return true;
        }
    }
});
*/
QTom.WorldMenu = Tx.extend(Tx.ScrollContainer, {
    vertical:true,
    minimized:false,
    canMinimize: true,
    selectable: true,
    multiselect:false,
    focusIndex:0,
    offset:0,
    prevArrow: 'world-menu-arrow-up',
    nextArrow: 'world-menu-arrow-down',
    initComponent: function(){
        Tx.ScrollContainer.prototype.initComponent.apply(this, arguments);
        this.minimizedItem = new Tx.Component({element:'world-menu-minimized-text'});
        this.minimizedItem.addEvent('mouseover', function(){this.minimizedItem.setFocus(true)}, this);
        this.minimizedItem.addEvent('click', function(){this.maximize()}, this);
        this.fx = new Tx.Animate();
        this.itemHeight = Tx.Device.isLowResolution() ? -32 : -43;
        this.minHeight = Tx.Device.isLowResolution() ? 32 : 43;
        this.maxHeight = Tx.Device.isLowResolution() ? 160 : 215;
        this.contentEl = Tx.get('world-menu-scroller');
        this.prevArrow = new Tx.Component({element:this.prevArrow,removeSelected:true});
        this.nextArrow = new Tx.Component({element:this.nextArrow,removeSelected:true});
        this.prevArrow.addEvent('mouseover', this.onArrowOver, this);
        this.nextArrow.addEvent('mouseover', this.onArrowOver, this);
        this.prevArrow.addEvent('click', this.onArrowClick, this);
        this.nextArrow.addEvent('click', this.onArrowClick, this);
    },
    onArrowOver: function(el){
        el.setFocus(true);
    },
    onArrowClick: function(el){
        el.setSelected(true);
    },
    minimize: function() {
        if (this.canMinimize && !this.minimized){
            this.minimized = true;
            this.prevArrow.hide();
            this.nextArrow.hide();
            this.fx.animate(this.element.dom.style, 'height', 1000, this.maxHeight, this.minHeight, 'px', function(){
                this.element.addClass('minimized');
                Tx.fly('marketing-menu').show();
            }, this);
            if (this.hasFocus){
                this.minimizedItem.setFocus(true);
            }
        }
    },
    maximize: function() {
        Tx.fly('marketing-menu').hide();
        this.element.removeClass('minimized');
        this.minimizedItem.setFocus(false);
        this.focusItem(this.focusIndex);
        this.fx.animate(this.element.dom.style, 'height', 1000, this.minHeight, this.maxHeight, 'px', function(){
            this.minimized = false;
            this.updateArrows();
        }, this);
    },
    toggle: function() {
        this[this.minimized ? 'maximize' : 'minimize']();
    },
    setFocus: function(state){
        //this.maximize();
        if (this.minimized && state === true){
            this.minimizedItem.setFocus(true);
            return;
        }
        else {
            this.minimizedItem.setFocus(false);
        }
        Tx.ScrollContainer.prototype.setFocus.apply(this, arguments);
    },
    updateArrows: function() {
        if (this.minimized){
            this.prevArrow.hide();
            this.nextArrow.hide();
            return;
        }
        Tx.ScrollContainer.prototype.updateArrows.apply(this, arguments);
    },
    canScrollPrev: function() {
        var result;
        if (this.minimized || this.items.length <= 5){
            result = false;
        }
        else {
            result = this.offset > 0;
        }
        this.prevArrow[result ? 'removeClass' : 'addClass']('disabled');
        return Tx.Device.hasMouse() || result;
    },
    canScrollNext: function() {
        var result;
        if (this.minimized || this.items.length <= 5){
            result = false;
        }
        else {
             result = this.offset < (this.items.length -5);
        }
        this.nextArrow[result ? 'removeClass' : 'addClass']('disabled');
        return Tx.Device.hasMouse() || result;
    },
    setData: function(worlds){
        this.data = worlds;
        var contentEl = this.getContentElement(), el, world, html=[];
        this.removeItems();
        for(var i= 0, l=worlds.length; i<l; i++){
            world = worlds[i];
            html.push('<div class="button-menu">'+Tx.htmlspecialchars(world.name)+'</div>');
        }
        contentEl.setHtml(html);
        contentEl.query('.button-menu').each(function(el, index){
            this.add(new Tx.Component({element:el, world:worlds[index], itemIndex:index}));
        }, this);
        this.offset = 0;
        this.focusIndex = 0;
        this.updateScrollPosition();
        this.updateArrows();

    },
    onAction: function() {
        if (this.minimized){
            this.maximize();
            return true;
        }
        this.selectItem(this.focusIndex);
        var item = this.getFocusItem();
        if (item && item.world){
            this.fireEvent('action', [item, item.world]);
            return true;
        }
    },
    handleKey: function(key){
        if (TXApplication.playingAd){
            return;
        }
        switch(key){
            case TX_KEY_UP: return this.moveUp();
            case TX_KEY_DOWN: return this.moveDown();
            case TX_KEY_ENTER: return this.onAction();
        }
    },
    moveUp: function() {
        if (this.minimized){
            return this.up;
        }
        if (this.focusIndex > 0){
            this.focusItem(this.focusIndex - 1);
            if (this.focusIndex < this.offset + 2){
                this.updateScrollPosition();
            }
            return true;
        }
        return this.up;
    },
    moveDown: function() {
        if(this.minimized){
            return this.down;
        }
        if (this.focusIndex == this.items.length -1){
            return this.down;
        }
        this.focusItem(Math.min(this.items.length-1, this.focusIndex + 1));
        this.updateScrollPosition();
        return true;
    },
    updateScrollPosition: function() {
        var index = this.focusIndex, last = this.items.length-5;
        this.offset = Math.max(0,Math.min(last,index-2));
        this.setScrollOffset();
        this.updateArrows();
    },
    setScrollOffset: function() {
        var value = this.offset * this.itemHeight;
        if (Tx.Device.isPhilips()){
            Tx.byId('world-menu').scrollTop = value*-1;
        }
        else {
            this.contentEl.setStyle('marginTop',(value)+'px');
        }
    },
    focusLast: function() {
        this.focusItem(Math.min(this.items.length-1, 4+this.offset));
        //this.updateScrollPosition();
    },
    focusLastItem: function() {
        this.focusLast();
    },
    onPrevArrowClick: function() {
        this.offset = Math.max(0,this.offset-2);
        this.setScrollOffset();
        this.updateArrows();
    },
    onNextArrowClick: function() {
        this.offset = Math.min(this.items.length - 5,this.offset+2);
        this.setScrollOffset();
        this.updateArrows();
    }

});

QTom.CurrentVideo = Tx.extend(Tx.Component, {
    initComponent: function() {
        Tx.Component.prototype.initComponent.apply(this, arguments);
        this.image = Tx.get('current-video-image');
        this.artist = Tx.get('current-video-artist');
        this.title = Tx.get('current-video-title');
    },
    setAsset: function(asset) {
        if (asset){
            this.asset = asset;
            this.image.attr('src',asset.getImage('teaserImage'));
            this.artist.setHtml(Tx.htmlspecialchars(asset.artist || asset.name));
            this.title.setHtml(Tx.htmlspecialchars(asset.title || ''));
            return true;
        }
    },
    setPaused: function() {
        this.element.addClass('paused');
    },
    setPlaying:function() {
        this.removeClass('paused');
    },
    setImpressum: function() {
        this.image.attr('src','');
        this.artist.setHtml('Impressum');
        this.title.setHtml('');
    }
});
QTom.ChannelSelectionItem = Tx.extend(Tx.Component, {

});
QTom.ChannelSelection = Tx.extend(Tx.ScrollContainer, {
    row:0,
    col:0,
    itemHeight: Tx.Device.isLowResolution() ? -136 : -180,
    marginTop:0,
    initComponent: function(){
        Tx.ScrollContainer.prototype.initComponent.apply(this, arguments);
        this.header = Tx.get('channel-selection-header-text');
        this.scrollbar = new QTom.Scrollbar();
        this.scrollbar.setContentHeight(this.itemHeight * -3);
        this.scrollbar.addEvent('arrow', this.onScrollbarClick, this);
    },
    onScrollbarClick: function(scrollbar, item){
        switch(item.name){
            case 'down':
                this.moveDown();
                if (this.focusIndex < 6){
                    this.moveDown();
                }
                break;
            case 'up':
                if (this.isLastRow()){
                    this.moveUp();
                    this.moveUp();
                }
                else {
                    this.moveUp();
                }
                break;
        }
    },
    isLastRow: function() {
      return this.focusIndex >= Math.floor(this.items.length / 3) * 3
    },
    setHeader: function(text){
        this.header.setHtml(Tx.htmlspecialchars(text));
    },
    setChannels: function(channels){
        this.data = channels;
        var contentEl = this.getContentElement(), el, channel, html=[];
        this.removeItems();
        for(var i= 0, l=channels.length; i<l; i++){
            channel = channels[i];
            html = [];
            el = Tx.get(document.createElement('div'));
            el.addClass('channel-selection-item');
            html.push('<div class="channel-selection-button"></div>');
            html.push('<img src="'+channel.getImage('teaserImage')+'" /><br />');
            if (channel.hasControllers()){
                html.push('<img class="badget-qme" src="img/badges_qme.png" alt="" />');
            }
            if (channel.isPremium()){
                html.push('<img class="badget-qtomplus" src="img/badges_qtomplus.png" alt="" />');
            }
            html.push('<div class="channel-name">'+Tx.htmlspecialchars(channel.name)+'</div>');
            el.setHtml(html);
            contentEl.insertChild(el);
            this.add(QTom.ChannelSelectionItem, {element:el.getId(),channel:channel});
        }
        this.focusIndex = 0;
        this.scrollbar.setTotalHeight(Math.ceil(this.items.length / 3) * this.itemHeight * -1);
        this.updateScrollPosition();
    },
    focusItem: function() {
        Tx.ScrollContainer.prototype.focusItem.apply(this, arguments);
        var item = this.getFocusItem();
        if (!item){
            return;
        }
        var channel = item.channel, world = channel.world, bgImage = QTom.getMediaUrl(channel.channelSelectionBackgroundImage || world.channelSelectionBackgroundImage || '');
        Tx.fly('channel-selection-header-background').attr('src',bgImage);
    },
    onAction: function(){
        var item = this.getFocusItem();
        if (item && item.channel){
            this.fireEvent('select', [item.channel, item]);
        }
        return true;
    },
    handleKey: function(key){
        switch(key){
            case TX_KEY_LEFT: return this.moveLeft();
            case TX_KEY_RIGHT: return this.moveRight();
            case TX_KEY_UP: return this.moveUp();
            case TX_KEY_DOWN: return this.moveDown();
            case TX_KEY_ENTER: return this.onAction();
        }
    },
    moveLeft: function() {
        if (this.focusIndex > 0  && (this.focusIndex % 3 != 0)) {
            this.focusItem(this.focusIndex -1);
            return true
        }
        return this.left;

    },
    moveRight: function(){
        if (this.focusIndex < this.items.length-1 && (this.focusIndex % 3 != 2)){
            this.focusItem(this.focusIndex + 1);
            return true;
        }
        return this.right;
    },
    moveUp: function() {
        if (this.focusIndex > 2){
            this.focusItem(this.focusIndex - 3);
            this.updateScrollPosition();
            return true;
        }
        return this.up;
    },
    moveDown: function() {
        if (this.focusIndex == this.items.length - (this.items.length % 3)){
            return this.down;
        }
        this.focusItem(Math.min(this.items.length-1, this.focusIndex + 3));
        this.updateScrollPosition();
        return true;
    },
    updateScrollPosition: function() {
        var row = Math.floor(this.focusIndex / 3),lastRow = Math.floor(this.items.length / 3)-1;
        if (row > 1 && this.items.length > 9){
            var value =((Math.min(row,lastRow)-1) * this.itemHeight);
            this.contentEl.setStyle('marginTop', value+'px');
            this.scrollbar.setScrollPosition(value*-1);
        }
        else {
            this.contentEl.setStyle('marginTop', 0);
            this.scrollbar.setScrollPosition(0);
        }
    }
});
QTom.ChannelControllerButton = Tx.extend(Tx.Component, {
    position:3,
    initComponent: function() {
        Tx.Component.prototype.initComponent.apply(this, arguments);
        this.setPosition(3);
        this.leftText = this.element.query('.left').get(0);
        this.rightText = this.element.query('.right').get(0);
        if (Tx.Device.hasMouse()){
            var map = Tx.fly(this.map);
            if (map){
                Tx.fly(this.map).query('area').each(function(el, index){
                    el.controllerIndex = index+1;
                    Tx.fly(el).addEventListener('click', this.onButtonClick.bind(this));
                }, this);
            }
        }
    },
    onButtonClick: function(event){
        var index = event.currentTarget.controllerIndex;
        if (index){
            this.setPosition(index);
        }
    },
    setPosition: function(pos){
        if (pos < 1 || pos > 5){
            return;
        }
        this.element.removeClass('pos'+this.position);
        this.position = pos;
        this.element.addClass('pos'+pos);
    },
    getPosition: function() {
        return this.position;
    },
    resetPosition: function(){
        this.setPosition(3);
    },
    setText: function(leftText, rightText){
        this.leftText.setHtml(leftText);
        this.rightText.setHtml(rightText);
    },
    handleKey: function(key){
        switch(key){
            case TX_KEY_UP:
                if (this.position < 5){
                    this.setPosition(this.position+1);
                    return true;
                }
                break;
            case TX_KEY_DOWN:
                if(this.position > 1){
                    this.setPosition(this.position-1);
                    return true;
                }
                break;
            case TX_KEY_LEFT: return this.left;
            case TX_KEY_RIGHT: return this.right;
        }
        return false;
    }
});
QTom.ChannelController = Tx.extend(Tx.Control, {
    numControllers: 3,
    defaultItem:'channel-controller-1',
    subChannel: '333',
    initComponent: function(){
        Tx.Control.prototype.initComponent.apply(this, arguments);
        this.add(QTom.ChannelControllerButton, {element:'channel-controller-1',ref:'controller1',left:this.onMoveLeft, right:this.onMoveRight, scope:this, removeSelected:true, map:'channel-controller-1-map'});
        this.add(QTom.ChannelControllerButton, {element:'channel-controller-2',ref:'controller2',left:this.onMoveLeft, right:this.onMoveRight, scope:this, removeSelected:true, map:'channel-controller-2-map'});
        this.add(QTom.ChannelControllerButton, {element:'channel-controller-3',ref:'controller3',left:this.onMoveLeft, right:this.onMoveRight, scope:this, removeSelected:true, map:'channel-controller-3-map'});
        this.add(Tx.Component, {element:'controller-button-accept', action:'accept',left:this.onMoveLeft, down:'controller-button-cancel', scope:this, removeSelected:true});
        this.add(Tx.Component, {element:'controller-button-cancel', action:'cancel',left:this.onMoveLeft, up: 'controller-button-accept', scope:this, removeSelected:true});
        this.setDefaultControllerDescription();
    },
    setDefaultControllerDescription: function() {
        var message = QTom.getMessage(QTom.MESSAGE_CONTROLLER_TEXT);
        if (message){
            this.setControllerDescription(message.text);
        }
    },
    setControllerDescription: function(text){
        Tx.fly('channel-controller-info').setHtml(Tx.htmlspecialchars(text));
    },
    onMoveLeft: function(){
        switch(this.currentItem){
            case 'channel-controller-1': return this.left;
            case 'channel-controller-2': return this.numControllers > 1 ? 'channel-controller-1' : 'controller-button-accept';
            case 'channel-controller-3': return this.numControllers > 2 ? 'channel-controller-2' : 'controller-button-accept';
            case 'controller-button-accept':
            case 'controller-button-cancel': return this.numControllers == 3 ? 'channel-controller-3' : (this.numControllers == 2 ? 'channel-controller-2' : 'channel-controller-1' );
        }
    },
    onMoveRight: function() {
        switch(this.currentItem){
            case 'channel-controller-1': return this.numControllers > 1 ? 'channel-controller-2':'controller-button-accept';
            case 'channel-controller-2': return this.numControllers > 2 ? 'channel-controller-3':'controller-button-accept';
            case 'channel-controller-3': return 'controller-button-accept';
            case 'controller-button-accept':
            case 'controller-button-cancel': return null;
        }
    },
    setControllerValues: function(num, leftText, rightText, position){
        var controller = this['controller'+num];
        if (controller){
            controller.setText(leftText, rightText);
            controller.setPosition(position || 3);
        }
    },
    setControllerNum: function(num){
        if (num >= 1 && num <= 3){
            this.numControllers = num;
            this.element.removeClass('one').removeClass('two').removeClass('three');
            switch (num){
                case 1 : this.element.addClass('one'); break;
                case 2 : this.element.addClass('two'); break;
                case 3 : this.element.addClass('three'); break;
            }
        }
    },
    getValue: function() {
        var result = [];
        for (var i=1; i<4; i++){
            if (this.numControllers >= i){
                var controller = this['controller'+i];
                if (controller){
                    result.push(String(controller.getPosition()));
                }
                else {
                    result.push('');
                }
            }
            else {
                result.push('');
            }
        }
        return result.join('');
    },
    setChannel: function(channel){
        if (this.channel && this.channel.id == channel.id){
            return;
        }
        this.channel = channel;
        if (typeof channel.controllerDescription == 'string'){
            this.setControllerDescription(channel.controllerDescription);
        }
        else {
            this.setDefaultControllerDescription();
        }
        var controllers = channel.getControllers(), controller;
        this.setControllerNum(controllers.length);
        for (var i= 0, l=controllers.length; i<l; i++){
            controller = controllers[i];
            this.setControllerValues(i+1, controller.left, controller.right);
        }
    },
    setSubchannel: function(subchannel){
        var controller, i;
        subchannel = subchannel || '333';
        //if (this.subChannel && this.subChannel == subchannel){
        //    return;
        //}
        this.subChannel = subchannel;
        for (i=0; i<3; i++) {
            controller = this['controller'+(i+1)];
            if (controller){
                controller.setPosition(Number(subchannel.charAt(i)));
            }
        }
    }
    /*
    ,
    handleKey: function(key){
        return QTom.ChannelController.prototype.handleKey.call(this, key);
        switch (key){
            case TX_KEY_1: this.setFocus('channel-controller-1'); break;
            case TX_KEY_2: this.setFocus('channel-controller-2'); break;
            case TX_KEY_3: this.setFocus('channel-controller-3'); break;
        }
    }
    */
});
QTom.ButtonPlaylist = Tx.extend(Tx.Component, {
    setActive: function(state){
        //this.element[state ? 'addClass' : 'removeClass']('active');
    },
    reset:function() {
        this.setActive(false);
    }
});
QTom.PlayerControl = Tx.extend(Tx.Control, {
    defaultItem: 'button-qme',
    initComponent: function() {
        Tx.Control.prototype.initComponent.apply(this, arguments);
        this.add(Tx.Component, {element:'button-qme', left:this.left, right:'button-playlist',down:this.down, action:'qme',ref:'buttonQme',removeSelected:true});
        this.add(QTom.ButtonPlaylist, {element:'button-playlist', ref: 'buttonPlaylist', left:'button-qme', right:'button-share',down:this.down, action:'playlist', removeSelected:true});
        this.add(Tx.Component, {element:'button-share', left:'button-playlist', right:'button-skip',down:this.down, action:'share',removeSelected:true});
        this.add(Tx.Component, {element:'button-skip', left:'button-share', right:'button-fullscreen',down:this.down, action:'skip',removeSelected:true});
        this.add(Tx.Component, {element:'button-fullscreen', left:'button-skip', right:this.right,down:this.down, action:'fullscreen',removeSelected:true});
    },
    onAction: function(component){
        if (component.id == 'button-playlist'){
            component.setActive(true);
        }
    },
    setQmeState: function(enabled) {
        this.buttonQme.enabled = !!enabled;
        this.buttonQme[!!enabled ? 'removeClass' : 'addClass']('disabled');
    },
    setRemoveState: function(state){
        this.element[!!state ? 'addClass' : 'removeClass']('remove');
    } ,
    setPlaylistActiveState: function(state){
        this.buttonPlaylist[!!state ? 'addClass' : 'removeClass']('active');
    }
});
QTom.FullscreenPlayerControl = Tx.extend(Tx.Control, {
    defaultItem: 'fullscreen-button-qme',
    initComponent: function() {
        Tx.Control.prototype.initComponent.apply(this, arguments);
        this.add(Tx.Component, {element:'fullscreen-button-qme', left:null, right:'fullscreen-button-playlist',down:this.down, action:'qme',ref:'buttonQme',removeSelected:true});
        this.add(Tx.Component, {element:'fullscreen-button-playlist',  ref:'playlistButton', left:'fullscreen-button-qme', right:'fullscreen-button-share',down:this.down, action:'playlist',removeSelected:true});
        this.add(Tx.Component, {element:'fullscreen-button-share', left:'fullscreen-button-playlist', right:'fullscreen-button-play-pause',down:this.down, action:'share',removeSelected:true});
        this.add(Tx.Component, {element:'fullscreen-button-play-pause', left:'fullscreen-button-share', right:'fullscreen-button-skip', down:this.down, action:'toggle',removeSelected:true});
        this.add(Tx.Component, {element:'fullscreen-button-skip', left:'fullscreen-button-play-pause', right:'fullscreen-button-info',down:this.down, action:'skip',removeSelected:true});
        this.add(Tx.Component, {element:'fullscreen-button-info', left:'fullscreen-button-skip', right:'fullscreen-button-fullscreen',down:this.down, action:'info',removeSelected:true});
        this.add(Tx.Component, {element:'fullscreen-button-fullscreen', left:'fullscreen-button-info', right:(Tx.Device.isNetcast() && !Tx.Device.isBOX()) ? 'fullscreen-button-q-menu' : null,down:this.down, action:'windowed',removeSelected:true});
        if (Tx.Device.isNetcast() && !Tx.Device.isBOX()){
            this.add(Tx.Component, {element:'fullscreen-button-q-menu', left:'fullscreen-button-fullscreen', right:null,down:this.down, action:'qmenu',removeSelected:true});
        }
        this.qtomPlusButton = QTom.qtomPlusButton;
        this.add(this.qtomPlusButton);
    },
    handleKey: function(key){
        switch(key){
            case TX_KEY_UP:
                if (this.qtomPlusButton.visible){
                    this.setFocus('qtom-plus');
                    return null;
                }
                break;
            case TX_KEY_DOWN:
                if (this.currentItem == 'qtom-plus'){
                    this.setFocus('fullscreen-button-qme');
                }
                break;
        }
        return Tx.Control.prototype.handleKey.apply(this, arguments);
    },
    setQmeState: function(enabled) {
        this.buttonQme.enabled = !!enabled;
        this.buttonQme[!!enabled ? 'removeClass' : 'addClass']('disabled');
    },
    setPaused: function(){
        this.element.addClass('paused');
    },
    setPlaying: function() {
        this.element.removeClass('paused');
    },
    setRemoveState: function(state){
        this.element[!!state ? 'addClass' : 'removeClass']('remove');
    } ,
    setPlaylistActiveState: function(state){
        this.playlistButton[!!state ? 'addClass' : 'removeClass']('active');
    }
});
QTom.PlaylistItem = Tx.extend(Tx.Component, {
    removeSelected:true,
    disabled: false,
    initComponent: function() {
        Tx.Component.prototype.initComponent.apply(this, arguments);
        this.image = this.element.query('.video-preview-image').get(0);
        this.artist = this.element.query('.artist').get(0);
        this.title = this.element.query('.title').get(0);
    },
    setAsset: function(asset){
        this.asset = asset;
        this.image.attr('src', asset.getImage('teaserImage'));
        this.artist.setHtml(Tx.htmlspecialchars(asset.artist || asset.name));
        this.title.setHtml(Tx.htmlspecialchars(asset.title || ''));
    },
    clear: function() {
        this.asset = null;
        this.image.attr('src', '');
        this.artist.setHtml('');
        this.title.setHtml('');
    },
    setDisabled: function(state) {
        this.disabled = !!state;
        this.element[this.disabled ? 'addClass' : 'removeClass']('disabled');
    }
});
QTom.QPlaylist = Tx.extend(Tx.Container, {
    initComponent: function() {
        Tx.Container.prototype.initComponent.apply(this, arguments);
        this.assets = [];
        this.musicClips = [];
        this.element.query('.video-container').each(function(element, index){
            this.add(QTom.PlaylistItem, {element:element});
        }, this);
        this.scroller = Tx.get('video-preview-scroller');
        this.itemSize = Tx.Device.isLowResolution() ? 191 * 0.75 : 191;
        this.fx = new Tx.Animate();
    },
    setAssets: function(assets){
        var asset, i, l, disabled = false, item;
        this.assets = [];
        this.musicClips = [];
        this.fx.stop();
        this.scroller.removeClass('animate');
        this.scroller.setStyle('marginLeft','0');
        for(i=0, l=assets.length; i<l; i++){
            asset = assets[i];
            if (asset){
                this.assets.push(asset);
                if (asset.isMusicClip() || asset.isEditorialContent()){
                    this.musicClips.push(asset);
                }
            }
        }
        for (i=0, l=this.items.length; i<l; i++){
            asset = this.musicClips[i+1];
            if (!asset){
                continue;
            }
            item = this.items[i];
            item.setDisabled(disabled);
            asset.disabled = disabled;
            if (!asset.canSkip()){
                disabled = true;
            }
            this.setItem(item, asset);
        }
    },
    setItem: function(item, data){
        if (data){
            item.setAsset(data);
        }
        else {
            item.clear();
        }
    },
    getFirstMusicClip: function() {
        return this.musicClips[0];
    },
    getFirstItem: function() {
        return this.assets[0];
    },
    getNextItem: function() {
        return this.assets[1];
    },
    scrollLeft: function(item, callback, scope){
        /*
        this.scroller.addClass('animate');
        this.scroller.setStyle.defer(this.scroller, 'marginLeft',(-numItems * this.itemSize)+'px');
        callback.delay(1000, scope);
        */
        var extraOffset = Tx.fly('video-preview-wrapper').dom.offsetLeft;
        this.fx.animate(this.scroller.dom.style, 'marginLeft',400*(item.listIndex+1), 0, -(item.element.dom.offsetLeft+extraOffset),'px',callback, scope);

    },
    scrollLeftByOne: function(callback, scope){
        this.scrollLeft(this.items[0], callback, scope);
    },
    focusNext:function () {
        if (this.focusIndex > 2) {
            return this.vertical ? this.down : this.right;
        }
        this.focusItem(this.focusIndex + 1);
        return true;
    }
});
QTom.LoadingIndicator = function(element, options){
    this.position = 0;
    this.offset = Tx.Device.isLowResolution() ? 90 : 120;
    Tx.apply(this, options);
    this.element = Tx.get(element);
};
Tx.apply(QTom.LoadingIndicator.prototype, {
    show: function(x,y){
        this.element.setStyles({
            left:x+'px',
            top:y+'px'
        });
        this.start();
    },
    hide: function() {
        this.stop();
        this.element.setStyle('top','-1000px');
    },
    start: function() {
        this.stop();
        this.timer = setInterval(this.onTimer.bind(this), 100);
    },
    stop: function() {
        if (this.timer){
            clearInterval(this.timer);
            this.timer = null;
        }
    },
    onTimer: function() {
        this.position++;
        if (this.position > 58){
            this.position = 0;
        }
        this.element.setStyle('backgroundPosition','-'+(this.position*this.offset)+'px top');
    }
});
QTom.AssetInfo = Tx.extend(Tx.Component, {
    visible:false,
    initComponent: function() {
        Tx.Component.prototype.initComponent.apply(this, arguments);
        this.artist = this.element.query('.artist').get(0);
        this.title = this.element.query('.title').get(0);
        this.defaultBackground = this.element.query('.default').get(0);
        this.customBackground = this.element.query('.custom').get(0);
    },
    show: function(){
        Tx.Component.prototype.show.apply(this, arguments);
        this.visible = true;
    },
    showAsset: function(asset, time){
        QTom.stopTimer('assetInfo');
        QTom.stopTimer('qtomPlusButton');
        if (this.hideTimeout){
            clearTimeout(this.hideTimeout);
        }
        QTom.qtomPlusButton.hide();
        this.artist.setHtml(Tx.htmlspecialchars(asset.artist));
        this.title.setHtml(Tx.htmlspecialchars(asset.title));
        this.show();
        this.visible = true;
        this.hideTimeout = this.hide.delay(time || 7000, this);
    },
    hide: function(noEvent) {
        if (!this.visible){
            noEvent = true;
        }
        Tx.Component.prototype.hide.apply(this, arguments);
        if (noEvent !== true){
            this.fireEvent('hide');
        }
    },
    setBackground: function(image) {
        Tx.log('AssetInfo.setBackground', image);
        if (image == '') {
            this.defaultBackground.show();
            this.customBackground.attr('src', 'img/nix.gif');
            this.customBackground.hide();
        }
        else {
            this.defaultBackground.hide();
            this.customBackground.attr('src', image);
            this.customBackground.show();
        }
    }
});
QTom.QTomPlusButton = Tx.extend(Tx.Component, {
    element:'qtom-plus',
    visible:false,
    buttonEnabled:false,
    showOnChannelChange:false,
    showOnSubChannelChange:false,
    showAfterXClips:3,
    currentButton:0,
    text: '',
    duration:0,
    content: '',
    initComponent: function(){
        Tx.Component.prototype.initComponent.apply(this, arguments);
        this.textElement = Tx.get('qtom-plus-text');
        this.buttons = [];
    },
    setText: function(text){
        this.text = text;
        this.textElement.setHtml(Tx.htmlspecialchars(text));
    },
    setDuration: function(duration){
        duration = parseInt(duration);
        if (duration){
            this.duration = duration * 1000;
        }
        else {
            this.duration = 0;
        }
    },
    handleKey: function(key){
        if (key == TX_KEY_ENTER){
            QTom.handleNotificationAction(this.content);
            return true;
        }
    },
    setContent: function(content) {
        if (!content){
            this.content = '';
        }
        else {
            this.content = String(content);
        }
    },
    setConfig: function(config){
        if (!config){
            return;
        }
        this.config = config;
        if (config){
            var attrs = config['@attributes'] || config;
            this.buttonEnabled = attrs.buttonEnabled == 'true';
            this.showOnChannelChange = attrs.showOnChannelChange == 'true';
            this.showOnSubChannelChange = attrs.showOnSubChannelChange == 'true';
            this.showAfterXClips = attrs.showAfterXClips == 'false' ? 0 : Number(attrs.showAfterXClips);
        }
        if (config.buttons){
            var button = config.buttons.button;
            if ( button && Tx.typeOf(button) !== 'array'){
                button = [button];
            }
            if(button){
                this.buttons = button;
            }
        }
    },
    show: function(){
        this.currentButton = 0;
        if (this.buttons.length == 0){
            return;
        }
        this.updateCurrentButton();
        Tx.Component.prototype.show.apply(this, arguments);
        this.visible = true;
        this.run();
    },
    hide: function(noEvent) {
        if (!this.visible){
            noEvent = true;
        }
        Tx.Component.prototype.hide.apply(this,arguments);
        if (noEvent !== true){
            this.fireEvent('hide');
        }
    },
    updateCurrentButton: function() {
        var button = this.buttons[this.currentButton];
        if (button){
            var attrs = button['@attributes'] || button;
            this.setText(attrs.text);
            this.setDuration(attrs.displayDuration);
            this.setContent(attrs.content);
        }
        else {
            this.setText('');
            this.setDuration(0);
            this.setContent('');
        }
    },
    run: function() {
        if (this.duration > 0){
            this.next.delay(this.duration, this);
        }
        else {
            this.hide();
        }
    },
    next: function() {
        this.currentButton++;
        this.updateCurrentButton();
        this.run();
    }
});

QTom.ProgresBar = function() {
    this.element = Tx.get('ad-progress');
    this.progress = Tx.get('progressbar');
    this.text = Tx.get('progress-values');
};
Tx.apply(QTom.ProgresBar.prototype, {
    reset: function() {
        this.progress.setStyle('width','0');
//        this.text.setHtml('0/0');
        this.text.setHtml('0');
    },
    setProgress: function(pos, total) {
        var percent = Math.floor((pos/total) * 100),
            totalSec = Math.floor(total / 1000),
            posSec = Math.floor(pos / 1000),
            remainSec = Math.floor((total-pos) / 1000);
        this.progress.setStyle('width', percent+'%');
//        this.text.setHtml(QTom.formatSeconds(posSec)+' / '+QTom.formatSeconds(totalSec));
        this.text.setHtml(QTom.formatSeconds(remainSec));
    },
    hide: function() {
        this.element.hide();
    },
    show: function() {
        this.element.show();
    }
});
QTom.NumberField = Tx.extend(Tx.Textfield, {
    maxLength:12,
    constructor: function() {
        Tx.Component.prototype.constructor.apply(this, arguments);
        this.input = Tx.get(this.input);
    },
    handleKey: function(key){
        var parentFn;
        if (Tx.Device.isSamsung()){
            parentFn = function() {return null};
        }
        else {
            parentFn = QTom.Textfield.prototype.handleKey.bind(this)
        }
        switch(key){
            case TX_KEY_RIGHT: return QTom.pointerDeviceIsActive || Tx.Device.isNetcast() ? parentFn(key) : this.right;
            case TX_KEY_DOWN: return QTom.pointerDeviceIsActive || Tx.Device.isNetcast() ? parentFn(key) : this.down;
            case TX_KEY_UP: return QTom.pointerDeviceIsActive || Tx.Device.isNetcast() ? parentFn(key) : this.up;
            case TX_KEY_LEFT: return QTom.pointerDeviceIsActive || Tx.Device.isNetcast() ? parentFn(key) : this.left;
            case TX_KEY_ENTER: return QTom.pointerDeviceIsActive || Tx.Device.isNetcast() ? Tx.SimpleKeyboard.handleKey(TX_KEY_ENTER) : null;
            case TX_KEY_BLUE: return QTom.pointerDeviceIsActive || Tx.Device.isNetcast() ? Tx.SimpleKeyboard.handleKey(TX_KEY_BLUE) : null;
            case TX_KEY_RED: return QTom.pointerDeviceIsActive || Tx.Device.isNetcast() ? Tx.SimpleKeyboard.handleKey(TX_KEY_RED) : null;
            case TX_KEY_GREEN: return QTom.pointerDeviceIsActive || Tx.Device.isNetcast() ? Tx.SimpleKeyboard.handleKey(TX_KEY_GREEN) : null;
            case TX_KEY_0: this.addString('0'); return true;
            case TX_KEY_1: this.addString('1'); return true;
            case TX_KEY_2: this.addString('2'); return true;
            case TX_KEY_3: this.addString('3'); return true;
            case TX_KEY_4: this.addString('4'); return true;
            case TX_KEY_5: this.addString('5'); return true;
            case TX_KEY_6: this.addString('6'); return true;
            case TX_KEY_7: this.addString('7'); return true;
            case TX_KEY_8: this.addString('8'); return true;
            case TX_KEY_9: this.addString('9'); return true;
            case TX_KEY_YELLOW: this.clear(); return true;
        }
    },
    setFocus: function(state){
        Tx.Component.prototype.setFocus.apply(this, arguments);
        if (state && (QTom.pointerDeviceIsActive || Tx.Device.isNetcast())){
            this.showKeyboard();
        }
        else {
            this.hideKeyboard();
        }
    },
    setFieldValue: function(value) {
        var formated = '';
        value = value.replace(/[^1234567890]/g,'');
        if (this.maxLength > 0){
            value = value.substr(0,this.maxLength);
        }
        for (var i= 0, l=value.length; i<l; i++){
            if (i>0 && i%4==0){
                formated = formated + ' ';
            }
            formated = formated + value.charAt(i);
        }
        this.input.dom.value = formated;
    },
    getValue: function() {
        var value = Tx.Textfield.prototype.getValue.call(this);
        return value.replace(/[^1234567890]/g,'');
    }
});
QTom.Textfield = Tx.extend(Tx.Textfield, {

});
QTom.Checkbox = Tx.extend(Tx.Component, {
    checked:false,
    noEvent: true,
    initComponent: function() {
        Tx.Component.prototype.initComponent.apply(this, arguments);
        this.setChecked(this.checked);
    },
    setChecked: function(state){
        this.checked = !! state;
        this[this.checked ? 'addClass' : 'removeClass']('checked');
    },
    isChecked: function() {
        return this.checked;
    },
    handleKey: function(key){
        if (key == TX_KEY_ENTER){
            this.setChecked(!this.checked);
            if (this.noEvent){
                return true;
            }
        }
        return false;
    }
});
QTom.Scrollbar = Tx.extend(Tx.Component, {
    element: 'channel-selection-scrollbar-container',
    totalHeight:0,
    contentHeight:0,
    initComponent: function() {
        Tx.Component.prototype.initComponent.apply(this, arguments);
        this.arrowUp = new Tx.Component({element:'scrollbar-arrow-up',name:'up',removeSelected:true});
        this.arrowDown = new Tx.Component({element:'scrollbar-arrow-down',name:'down', removeSelected:true});
        this.arrowUp.addEvent('mouseover', this.onArrowOver, this);
        this.arrowUp.addEvent('click', this.onArrowClick, this);
        this.arrowDown.addEvent('mouseover', this.onArrowOver, this);
        this.arrowDown.addEvent('click', this.onArrowClick, this);
        this.outer = Tx.get('scrollbar-outer');
        this.inner = Tx.get('scrollbar-inner');
        this.outerHeight = Tx.Device.isLowResolution() ? 346 : 462;
        this.totalHeight = this.outerHeight;
        this.contentHeight = this.outerHeight;
    },
    onArrowOver: function(el) {
        el.setFocus(true);
    },
    onArrowClick: function(el){
        el.setSelected(true);
        this.fireEvent('arrow', [el]);
    },
    setContentHeight: function(height) {
        this.contentHeight = height;
        this.updateInnerHeight();
    },
    setTotalHeight: function(height){
        if (height <= this.contentHeight){
            height = this.contentHeight;
            this.element.hide();
        }
        else {
            this.element.show();
        }
        this.totalHeight = height;
        this.updateInnerHeight();
    },
    updateInnerHeight: function() {
        this.innerHeight = Math.floor((this.outerHeight / this.totalHeight) * this.contentHeight);
        this.inner.setStyle('height', this.innerHeight+'px');
    },
    setScrollPosition: function(offset) {
        var top = Math.min(this.outerHeight - this.innerHeight, Math.floor((this.outerHeight / this.totalHeight) * offset));
        this.inner.setStyle('top', top+'px');
    }
});

QTom.Preloader = new (Tx.extend(Tx.Base, {
    numImages:0,
    numLoaded:0,
    numError:0,
    setting:false,
    init: function(){
        var div = document.createElement('div');
        Tx.fly(div).setStyles({
            position:'absolute',
            top: '-10000px',
            height:'9000px',
            width: '10000px',
            overflow:'hidden',
            left:'0px'
        });
        Tx.getBody().appendChild(div);
        this.div = div;
        this.onLoadBound = this.onLoad.bind(this);
        this.onErrorBound = this.onError.bind(this);
    },
    loadImages: function(images){
        var src;
        this.setting = true;
        this.numImages = 0;
        this.numLoaded = 0;
        this.numError = 0;
        for (var name in images){
            if (!this[name] && images.hasOwnProperty(name)){
                src = images[name];
                this.addImage(name, src);
            }
        }
        this.setting = false;
        this.check();
    },
    addImage: function(name, src){
        var img = document.createElement('img');
        img.onload = this.onLoadBound;
        img.onerror = this.onErrorBound;
        img.onabort = this.onErrorBound;
        this.numImages++;
        this[name] = img;
        this.div.appendChild(img);
        img.src = src
    },
    onLoad: function() {
        this.numLoaded++;
        this.check();
    },
    onError: function() {
        this.numError++;
        this.check();
    },
    check: function() {
        if (this.setting){
            return;
        }
        if (this.numLoaded + this.numError >= this.numImages){
            this.fireEvent('loaded');
        }
    },
    clear: function() {
        for (k in this) {
            if (this[k].src){
                delete this[k];
            }
        }
        this.div.innerHTML = '';
    }
}))();