/**
 * Created by JetBrains PhpStorm.
 * User: kasi
 * Date: 28.07.11
 * Time: 19:32
 * To change this template use File | Settings | File Templates.
 */

/*
KEY_TOOLS = 75
KEY_MUTE = 27
KEY_RETURN = 88
KEY_UP = 29460
KEY_DOWN = 29461
KEY_LEFT = 4
KEY_RIGHT = 5
KEY_WHEELDOWN = 29469
KEY_WHEELUP = 29468
KEY_ENTER = 29443
KEY_INFO = 31
KEY_EXIT = 45
KEY_RED = 108
KEY_GREEN = 20
KEY_YELLOW = 21
KEY_BLUE = 22
KEY_INFOLINK = 147
KEY_RW = 69
KEY_PAUSE = 74
KEY_FF = 72
KEY_PLAY = 71
KEY_STOP = 70
KEY_1 = 101
KEY_2 = 98
KEY_3 = 6
KEY_4 = 8
KEY_5 = 9
KEY_6 = 10
KEY_7 = 12
KEY_8 = 13
KEY_9 = 14
KEY_0 = 17
KEY_EMPTY = 0
KEY_PRECH = 259
KEY_SOURCE = 222
KEY_CHLIST = 84
KEY_MENU = 262
KEY_WLINK = 115
KEY_CC = 118
KEY_CONTENT = 261
KEY_FAVCH = 256
KEY_REC = 192
KEY_EMODE = 148
KEY_DMA = 260
KEY_PANEL_CH_UP = 105
KEY_PANEL_CH_DOWN = 106
KEY_PANEL_VOL_UP = 203
KEY_PANEL_VOL_DOWN = 204
KEY_PANEL_ENTER = 309
KEY_PANEL_SOURCE = 612
KEY_PANEL_MENU = 613
KEY_PANEL_POWER = 614
KEY_POWER = 76
KEY_TV = 77
KEY_VOL_UP = 7
KEY_VOL_DOWN = 11
KEY_CH_UP = 68
KEY_CH_DOWN = 65
KEY_TTX_MIX = 650
KEY_GUIDE = 651
KEY_SUBTITLE = 652
KEY_ASPECT = 653
KEY_DOLBY_SRR = 654
KEY_MTS = 655
KEY_12 = 1057
KEY_DISC_MENU = 1086
KEY_3D = 1219
KEY_PIP_ONOFF = 1032
KEY_AD = 1039
KEY_PMODE = 1040
KEY_SMODE = 1043
KEY_PIP_CHUP = 1050
KEY_PIP_CHDOWN = 1051
KEY_FF_ = 1078
KEY_REWIND_ = 1080
KEY_SUB_TITLE = 1089
KEY_SLEEP = 1097
KEY_D_AUDIO = 1236
KEY_D_FRONT_PLAY = 1243
KEY_D_VIEW_MODE = 1249
KEY_STEP = 1023
KEY_CALLER_ID = 1128
KEY_ZOOM1 = 1083
KEY_ANTENA = 1054
*/


Tx.Samsung = {
    widgetAPI: new Common.API.Widget(),
    tvKey: new Common.API.TVKeyValue(),
    pluginAPI: new Common.API.Plugin(),
    NNaviPlugin: null,

    getDeviceId: function() {
        var mac = Tx.Samsung.Network.getMacAddress();
        if (!mac) return false;
        return this.NNaviPlugin.GetDUID(mac);
    }

};

/**
 * Created by JetBrains PhpStorm.
 * User: kasi
 * Date: 28.07.11
 * Time: 19:38
 * To change this template use File | Settings | File Templates.
 */

Tx.Samsung.Network = new (Tx.extend(Tx.Base, {
    pluginId: 'pluginNetwork',
    plugin: null,
    autostart: true,
    checkInterval:2000,
    checkTimer:null,
    connected: false,

    constructor:function(){
        Tx.Base.prototype.constructor.call(this);
    },
    init: function(config){
        Tx.apply(this, config);
        this.plugin = document.getElementById(this.pluginId);
        if (!this.plugin){
            return false;
        }
        this.connected = this.checkConnection();
        if (this.autostart){
            this.start();
        }
        return this.connected;
    },
    checkConnection : function() {
        if(this.plugin) {
            try {
                return ((this.plugin.CheckPhysicalConnection(0) == 1) && (this.plugin.CheckHTTP(0) == 1)) ||
                ((this.plugin.CheckPhysicalConnection(1) == 1) && (this.plugin.CheckHTTP(1) == 1));
            } catch(e) {
                return true;
            }
        }
        return true;
    },
    getMacAddress: function() {
        return this.plugin ? (this.plugin.GetMAC ? this.plugin.GetMAC() :(this.plugin.GetHWAddr ? this.plugin.GetHWAddr(): false)) : false;
    },
    onTimer: function() {
        var connected = this.checkConnection();
        if (this.connected && !connected){
            this.fireEvent('disconnect');
        }
        if (!this.connected &&  connected){
            this.fireEvent('connect');
        }
        this.connected = connected;
    },
    start: function(){
        this.stop();
        this.checkTimer = setInterval(this.onTimer.bind(this), this.checkInterval);
    },
    stop: function() {
        if(this.checkTimer){
            clearInterval(this.checkTimer);
        }
    }

}));

/**
 * Created by JetBrains PhpStorm.
 * User: kasi
 * Date: 28.07.11
 * Time: 19:27
 * To change this template use File | Settings | File Templates.
 */

Tx.override(Tx.Video, {
    pluginPlayerId: 'pluginPlayer',
    left:50,
    top:50,
    width:488,
    height:300,
    pluginObjectTVMWId: 'pluginObjectTVMW',
    duration: 0,
    currentPos: 0,
    ready: false,
    bufferTimeout: 2000,
    init: function() {
        alert('plugin '+this.pluginPlayerId);
        this.plugin = Tx.byId(this.pluginPlayerId);
        Tx.Samsung.Events = {
            onCurrentPlayTime: this.onCurrentPlayTime.bind(this),
            onStreamInfoReady: this.onStreamInfoReady.bind(this),
            onBufferingStart: this.onBufferingStart.bind(this),
            onBufferingProgress: this.onBufferingProgress.bind(this),
            onBufferingComplete: this.onBufferingComplete.bind(this),
            onNetworkError: this.onNetworkError.bind(this),
            onConnectionFailed: this.onConnectionFailed.bind(this),
            onRenderingComplete: this.onRenderingComplete.bind(this)
        };
        if (this.plugin){
            this.plugin.OnCurrentPlayTime			= 'Tx.Samsung.Events.onCurrentPlayTime';
            this.plugin.OnStreamInfoReady			= 'Tx.Samsung.Events.onStreamInfoReady';
            this.plugin.OnBufferingStart			= 'Tx.Samsung.Events.onBufferingStart';
            this.plugin.OnBufferingProgress			= 'Tx.Samsung.Events.onBufferingProgress';
            this.plugin.OnBufferingComplete			= 'Tx.Samsung.Events.onBufferingComplete';
            this.plugin.OnConnectionFailed			= 'Tx.Samsung.Events.onConnectionFailed';
            this.plugin.OnNetworkDisconnected       = 'Tx.Samsung.Events.onNetworkError';
            this.plugin.OnRenderingComplete			= 'Tx.Samsung.Events.onRenderingComplete';
            this.mwPlugin = Tx.byId(this.pluginObjectTVMWId);
            /*
            if (this.mwPlugin){
                this.originalSource = this.mwPlugin.GetSource();
                this.mwPlugin.SetMediaSource();
            }
            */
        }
    },
    destroy: function() {
        this.plugin.Stop();
        if (this.mwPlugin && this.originalSource != null){
            this.mwPlugin.SetSource(this.originalSource);
            this.mwPlugin = null;
        }
        if (this.plugin.SetScreenRect){
            this.plugin.SetScreenRect(-1,0,0,0);
        }
        this.plugin = null;
    },
    load: function(video, isLivestream) {
        this.stop();
        this.currentPos = 0;
        this.ready = false;
        this.loading = false;
        this.isLivestream = (isLivestream === true);
        if (typeof video == 'string'){
            video = {
                url: video,
                mime:'video/mp4'
            }
        }
        this.video = video;
        if (!this.isLivestream){
            this.state = TX_STATE_STOPPED;
        }
        Tx.log('samsung load '+this.video.url);
    },
    playLivestream: function(video){
        if (typeof video == 'string'){
            video = {
                url: video,
                mime:'video/x-ms-wmv' //'video/x-mpegurl'
            }
        }
        this.load(video, true);
        this.play();
    },
    play: function() {
        if (!this.video || !this.video.url || this.loading){
            return;
        }
        Tx.log('Samsung play '+this.video.url);
        switch(this.state){
            case TX_STATE_BUFFERING:
            case TX_STATE_CONNECTING:
            case TX_STATE_ERROR:
            case TX_STATE_FINISHED:
            case TX_STATE_STOPPED:
                try {
                    Tx.log('Samsung Play '+this.video.url);
                    this.loading = true;
                    this.plugin.Play(this.video.url);
                    this.fireEvent('statechanged', [TX_STATE_PLAYING]);
                    this.state = TX_STATE_PLAYING;
                }
                catch(e){
                    this.state = TX_STATE_ERROR;
                }
                break;
            case TX_STATE_PAUSED:
                this.plugin.Resume();
                this.fireEvent('statechanged', [TX_STATE_PLAYING]);
                this.state = TX_STATE_PLAYING;
        }
    },
    stop: function() {
        if (!this.video || !this.video.url){
            return;
        }
        try {
            this.plugin.Stop();
            this.fireEvent('statechanged', [TX_STATE_STOPPED]);
            this.state = TX_STATE_STOPPED;
        }
        catch(e){
            this.state = TX_STATE_ERROR;
        }
    },
    pause: function() {
        if (!this.video || !this.video.url || !this.ready){
            return;
        }
        switch(this.state){
            case TX_STATE_ERROR:
            case TX_STATE_FINISHED:
            case TX_STATE_STOPPED:
            case TX_STATE_BUFFERING:
            case TX_STATE_CONNECTING:
                return;
            case TX_STATE_PAUSED:
                this.play();
                break;
            case TX_STATE_PLAYING:
                this.plugin.Pause();
                this.fireEvent('statechanged', [TX_STATE_PAUSED]);
                this.state = TX_STATE_PAUSED;
                break;
        }
    },
    forward: function(seconds){
        if (this.ready && (this.state == TX_STATE_PLAYING || this.state == TX_STATE_PAUSED) && this.currentPos > 0){
            try {
                return this.plugin.JumpForward(seconds);
            }
            catch(e){}
        }
    },
    rewind: function(seconds) {
        var currentPos = this.currentPos || 0;
        seconds = Math.min(Math.floor((currentPos +1000) / 1000), seconds);
        if (this.ready && (this.state == TX_STATE_PLAYING || this.state == TX_STATE_PAUSED) && this.currentPos > 0 && seconds > 0){
            try {
                return this.plugin.JumpBackward(seconds);
            }
            catch(e){
                Tx.error('Video.rewind', e);
            }
        }
    },
    onStreamInfoReady: function() {
        Tx.log('onStreamInfoReady');
        this.duration = this.plugin.GetDuration();
        this.ready = true;
        this.loading = false;
    },
    onCurrentPlayTime: function(time) {
        var progress;
        this.currentPos = time;
        if (this.state != TX_STATE_PLAYING){
            this.fireEvent('statechanged', [TX_STATE_PLAYING]);
            this.state = TX_STATE_PLAYING;
        }
        if (this.duration > 0){
            if (time >= this.duration){
                progress = '100%';
            }
            else {
                progress = Math.round((time / this.duration)*100)+'%';
            }
        }
        else {
            progress = 0;
        }
        this.fireEvent('progress', [progress, time, this.duration]);
    },
    startBufferTimer: function() {
        this.clearBufferTimer();
        if (!this.onNetworkErrorBound){
            this.onNetworkErrorBound = this.onNetworkError.bind(this);
        }
        this.bufferTimer = window.setTimeout(this.onNetworkErrorBound, this.bufferTimeout);
    },
    clearBufferTimer: function() {
        if (this.bufferTimer){
            window.clearTimeout(this.bufferTimer)
        }
    },
    onBufferingStart: function() {
        this.fireEvent('statechanged', [TX_STATE_BUFFERING]);
        this.state = TX_STATE_BUFFERING;
        this.startBufferTimer();
    },
    onBufferingProgress: function(percent) {
        if(this.state != TX_STATE_BUFFERING){
            this.fireEvent('statechanged', [TX_STATE_BUFFERING]);
            this.state = TX_STATE_BUFFERING;
        }
        this.fireEvent('bufferprogress', [percent]);
        this.startBufferTimer();
    },
    onBufferingComplete: function() {
        this.clearBufferTimer();
        this.fireEvent('statechanged', [TX_STATE_PLAYING]);
        this.state = TX_STATE_PLAYING;
    },
    onNetworkError: function() {
        Tx.log('onNetworkError');
        if (this.state != TX_STATE_ERROR){
            this.fireEvent('statechanged', [TX_STATE_ERROR]);
            this.state = TX_STATE_ERROR;
        }
        this.fireEvent('error', [TX_VIDEO_NETWORK_ERROR, 'Networkerror']);
    },
    onConnectionFailed: function() {
        Tx.log('onConnectionFailed');
        if (this.state != TX_STATE_ERROR){
            this.fireEvent('statechanged', [TX_STATE_ERROR]);
            this.state = TX_STATE_ERROR;
        }
        this.fireEvent('error', [TX_VIDEO_NETWORK_ERROR, 'Connection failed']);
    },
    onRenderingComplete: function() {
        this.fireEvent('statechanged', [TX_STATE_FINISHED]);
        this.fireEvent('finished');
        this.state = TX_STATE_FINISHED;
        this.currentPos = 0;
        this.ready = false;
    },
    setDimension:function(left, top, width, height) {
        left	= Math.min(window.innerWidth - 1, left);
        top	= Math.min(window.innerHeight - 1, top);
        width	= Math.min((window.innerWidth - left), width);
        height	= Math.min((window.innerHeight - top), height);
        this.plugin.SetDisplayArea(left, top, width, height);
    }
});

/**
 * Created by JetBrains PhpStorm.
 * User: kasi
 * Date: 04.08.11
 * Time: 18:27
 * To change this template use File | Settings | File Templates.
 */
/*
    VK_UP = tvKey.KEY_UP;
    VK_DOWN = tvKey.KEY_DOWN;
    VK_LEFT = tvKey.KEY_LEFT;
    VK_RIGHT = tvKey.KEY_RIGHT;
    VK_RED = tvKey.KEY_RED;
    VK_GREEN = tvKey.KEY_GREEN;
    VK_YELLOW = tvKey.KEY_YELLOW;
    VK_BLUE = tvKey.KEY_BLUE;
    VK_1 = tvKey.KEY_1;
    VK_2 = tvKey.KEY_2;
    VK_3 = tvKey.KEY_3;
    VK_4 = tvKey.KEY_4;
    VK_5 = tvKey.KEY_5;
    VK_6 = tvKey.KEY_6;
    VK_7 = tvKey.KEY_7;
    VK_8 = tvKey.KEY_8;
    VK_9 = tvKey.KEY_9;
    VK_0 = tvKey.KEY_0;
    VK_ENTER = tvKey.KEY_ENTER;
    VK_REWIND = tvKey.KEY_RW;
    VK_PAUSE = tvKey.KEY_PAUSE;
    VK_FF = VK_FAST_FWD = tvKey.KEY_FF;
    VK_PLAY = tvKey.KEY_PLAY;
    VK_STOP = tvKey.KEY_STOP;


    VK_TOOLS = tvKey.KEY_TOOLS;
    VK_MUTE = tvKey.KEY_MUTE;
    VK_RETURN = tvKey.KEY_RETURN;
    VK_WHEELDOWN = tvKey.KEY_WHEELDOWN;
    VK_WHEELUP = tvKey.KEY_WHEELUP;
    VK_INFO = tvKey.KEY_INFO;
    VK_EXIT = tvKey.KEY_EXIT;
    VK_INFOLINK = tvKey.KEY_INFOLINK;
    VK_EMPTY = tvKey.KEY_EMPTY;
    VK_PRECH = tvKey.KEY_PRECH;
    VK_SOURCE = tvKey.KEY_SOURCE;
    VK_CHLIST = tvKey.KEY_CHLIST;
    VK_MENU = tvKey.KEY_MENU;
    VK_WLINK = tvKey.KEY_WLINK;
    VK_CC = tvKey.KEY_CC;
    VK_CONTENT = tvKey.KEY_CONTENT;
    VK_FAVCH = tvKey.KEY_FAVCH;
    VK_RECORD = tvKey.KEY_REC;
    VK_EMODE = tvKey.KEY_EMODE;
    VK_DMA = tvKey.KEY_DMA;
    VK_CHANNEL_UP = tvKey.KEY_PANEL_CH_UP;
    VK_CHANNEL_DOWN = tvKey.KEY_PANEL_CH_DOWN;
    VK_VOLUME_UP = tvKey.KEY_PANEL_VOL_UP;
    VK_VOLUME_DOWN = tvKey.KEY_PANEL_VOL_DOWN;
    VK_ENTER = tvKey.KEY_PANEL_ENTER;
    VK_SOURCE = tvKey.KEY_PANEL_SOURCE;
    VK_MENU = tvKey.KEY_PANEL_MENU;
    VK_POWER = tvKey.KEY_PANEL_POWER;
    VK_POWER = tvKey.KEY_POWER;
    VK_TV = tvKey.KEY_TV;
    VK_VOLUME_UP = tvKey.KEY_VOL_UP;
    VK_VOLUME_DOWN = tvKey.KEY_VOL_DOWN;
    VK_CHANNEL_UP = tvKey.KEY_CH_UP;
    VK_CHANNEL_DOWN = tvKey.KEY_CH_DOWN;
    VK_TTX_MIX = tvKey.KEY_TTX_MIX;
    VK_GUIDE = tvKey.KEY_GUIDE;
    VK_SUBTITLE = tvKey.KEY_SUBTITLE;
    VK_ASPECT = tvKey.KEY_ASPECT;
    VK_DOLBY_SRR = tvKey.KEY_DOLBY_SRR;
    VK_MTS = tvKey.KEY_MTS;
    VK_12 = tvKey.KEY_12;
    VK_DISC_MENU = tvKey.KEY_DISC_MENU;
    VK_3D = tvKey.KEY_3D;
    VK_PIP_ONOFF = tvKey.KEY_PIP_ONOFF;
    VK_ADD = tvKey.KEY_AD;
    VK_PMODE = tvKey.KEY_PMODE;
    VK_SMODE = tvKey.KEY_SMODE;
    VK_PIP_CHUP = tvKey.KEY_PIP_CHUP;
    VK_PIP_CHDOWN = tvKey.KEY_PIP_CHDOWN;
    VK_FF = tvKey.KEY_FF;
    VK_REWIND = tvKey.KEY_REWIND;
    VK_SUBTITLE = tvKey.KEY_SUB_TITLE;
    VK_SPEEP = tvKey.KEY_SLEEP;
    VK_D_AUDIO = tvKey.KEY_D_AUDIO;
    VK_D_FRONT_PLAY = tvKey.KEY_D_FRONT_PLAY;
    VK_D_VIEW_MODE = tvKey.KEY_D_VIEW_MODE;
    VK_STEP = tvKey.KEY_STEP;
    VK_CALLER_ID = tvKey.KEY_CALLER_ID;
    VK_ZOOM1 = tvKey.KEY_ZOOM1;
    VK_ANTENA = tvKey.KEY_ANTENA;

 */
(function(tvKey, map){
    map[tvKey.KEY_LEFT] =TX_KEY_LEFT;
    map[tvKey.KEY_RIGHT] =TX_KEY_RIGHT;
    map[tvKey.KEY_UP] =TX_KEY_UP;
    map[tvKey.KEY_DOWN] =TX_KEY_DOWN;
    map[tvKey.KEY_ENTER] =TX_KEY_ENTER;
    map[tvKey.KEY_PANEL_ENTER] =TX_KEY_ENTER;
    map[tvKey.KEY_0] =TX_KEY_0;
    map[tvKey.KEY_1] =TX_KEY_1;
    map[tvKey.KEY_2] =TX_KEY_2;
    map[tvKey.KEY_3] =TX_KEY_3;
    map[tvKey.KEY_4] =TX_KEY_4;
    map[tvKey.KEY_5] =TX_KEY_5;
    map[tvKey.KEY_6] =TX_KEY_6;
    map[tvKey.KEY_7] =TX_KEY_7;
    map[tvKey.KEY_8] =TX_KEY_8;
    map[tvKey.KEY_9] =TX_KEY_9;
    map[tvKey.KEY_RED] =TX_KEY_RED;
    map[tvKey.KEY_GREEN] =TX_KEY_GREEN;
    map[tvKey.KEY_YELLOW] =TX_KEY_YELLOW;
    map[tvKey.KEY_BLUE] =TX_KEY_BLUE;
    map[tvKey.KEY_PLAY] =TX_KEY_PLAY;
    map[tvKey.KEY_STOP] =TX_KEY_STOP;
    map[tvKey.KEY_PAUSE] =TX_KEY_PAUSE;
    map[tvKey.KEY_RW] =TX_KEY_REWIND;
    map[tvKey.KEY_FF] =TX_KEY_FORWARD;
    map[tvKey.KEY_RETURN] =TX_KEY_RETURN;
    map[tvKey.KEY_BACK] =TX_KEY_BACK;
    //map[tvKey.KEY_] =TX_KEY_NEXT;
    map[tvKey.KEY_INFO] =TX_KEY_INFO;
    map[tvKey.KEY_EXIT] =TX_KEY_EXIT;
    map[tvKey.KEY_INFOLINK] =TX_KEY_PORTAL;
    map[tvKey.KEY_KEY_PANEL_VOL_UP] =TX_KEY_VOLUME_UP;
    map[tvKey.KEY_KEY_VOL_UP] =TX_KEY_VOLUME_UP;
    map[tvKey.KEY_KEY_PANEL_VOL_DOWN] =TX_KEY_VOLUME_DOWN;
    map[tvKey.KEY_KEY_VOL_DOWN] =TX_KEY_VOLUME_DOWN;
    map[tvKey.KEY_KEY_PANEL_CH_UP] =TX_KEY_CHANNEL_UP;
    map[tvKey.KEY_KEY_CH_UP] =TX_KEY_CHANNEL_UP;
    map[tvKey.KEY_KEY_PANEL_CH_DOWN] =TX_KEY_CHANNEL_DOWN;
    map[tvKey.KEY_KEY_CH_DOWN] =TX_KEY_CHANNEL_DOWN;
    map[tvKey.KEY_MUTE] =TX_KEY_MUTE;
    //map[tvKey.KEY_] =TX_KEY_BACK;
})(Tx.Samsung.tvKey, Tx.Remote.prototype.map);




/**
 * Created by JetBrains PhpStorm.
 * User: kasi
 * Date: 08.08.11
 * Time: 16:35
 * To change this template use File | Settings | File Templates.
 */

Tx.override(Tx.Application, {
    pluginNNaviID: 'pluginObjectNNavi',
    anchorId : 'anchor',
    onLoad: function() {
        alert('onLoad');
        window.onshow = window.onShow = this.onShow.bind(this);
        this.pluginAPI = Tx.Samsung.pluginAPI;
        this.tvKey = Tx.Samsung.tvKey;
        this.widgetApi = Tx.Samsung.widgetAPI;
        this.videoPlayer = new Tx.Video(this.videoCfg);
        this.videoPlayer.init();
        this.network = Tx.Samsung.Network;
        this.network.init();
        this.network.addEvent('disconnect', this.onDisconnect.bind(this));
        this.network.addEvent('connect', this.onConnect.bind(this));
        if (this.network.checkConnection()){
            this.onConnect();
        }
        this.widgetApi.sendReadyEvent();
        this.NNaviPlugin = Tx.Samsung.NNaviPlugin =  Tx.byId(this.pluginNNaviID);
        this.initKeys();
        this.initApplication();
        this.initNavigation();
        this.NNaviPlugin.SetBannerState(2);
        this.pluginAPI.SetBannerState(1);
        this.pluginAPI.unregistKey(this.tvKey.KEY_VOL_UP);
        this.pluginAPI.unregistKey(this.tvKey.KEY_VOL_DOWN);
        this.pluginAPI.unregistKey(this.tvKey.KEY_MUTE);
        alert('ready');
        this.onReady();
    },
    onUnload: function() {
        if (this.videoPlayer){
            this.videoPlayer.destroy();
        }
        if (this.network){
            this.network.stop();
        }
    },
    onShow: function() {
        alert('onShow()');
        try {
            //this.NNaviPlugin = Tx.Samsung.NNaviPlugin =  Tx.byId(this.pluginNNaviID);
            this.NNaviPlugin.SetBannerState(2);
            this.pluginAPI.SetBannerState(1);
            //this.pluginAPI.registAllKey();
            this.pluginAPI.unregistKey(this.tvKey.KEY_VOL_UP);
            this.pluginAPI.unregistKey(this.tvKey.KEY_VOL_DOWN);
            this.pluginAPI.unregistKey(this.tvKey.KEY_MUTE);
        }
        catch(e){
            alert(e);
        }

    },
    initKeys: function() {
        this.anchor = Tx.byId(this.anchorId);
        alert('initKeys '+(typeof this.anchor) + ' '+(typeof this.onKeyDown));
        try {
            this.anchor.onkeydown = this.onKeyDown.bind(this);
            this.anchor.focus();
        }
        catch(e){
            alert(e);
        }
    },
    onDisconnect: function() {

    },
    onConnect: function() {

    }
});

